SystemOrganization addCategory: #'XPath-Core'!
SystemOrganization addCategory: 'XPath-Core-DOM'!
SystemOrganization addCategory: 'XPath-Core-Exceptions'!
SystemOrganization addCategory: 'XPath-Core-Functions'!
SystemOrganization addCategory: 'XPath-Core-Parsers'!
SystemOrganization addCategory: 'XPath-Core-Streams'!

!XMLComment methodsFor: '*XPath-Core-DOM' stamp: 'monty 12/20/2014 20:55'!
asXPathString
	^ self string! !

XMLException subclass: #XPathException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathException commentStamp: 'monty 12/20/2014 19:26' prior: 0!
A base class for XPath exceptions.!

XPathException subclass: #XPathArgumentNumberException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathArgumentNumberException commentStamp: 'monty 1/18/2015 13:59' prior: 0!
Invoked for function calls with the wrong number of arguments.!

!XPathException methodsFor: 'appending' stamp: 'monty 1/6/2015 09:24'!
appendPosition: aPosition
	self
		append: aPosition
		withDescription: 'at pos.'! !

XPathException subclass: #XPathSyntaxException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathSyntaxException commentStamp: 'monty 1/18/2015 13:59' prior: 0!
Invoked for syntax errors in XPath expressions.!

XPathException subclass: #XPathTypeException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathTypeException commentStamp: 'monty 1/18/2015 13:55' prior: 0!
Invoked for type conversion errors.!

XPathException subclass: #XPathUndeclaredFunctionException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathUndeclaredFunctionException commentStamp: 'monty 1/18/2015 14:01' prior: 0!
Invoked for undeclared functions.!

XPathException subclass: #XPathUndeclaredVariableException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathUndeclaredVariableException commentStamp: 'monty 1/18/2015 14:01' prior: 0!
Invoked for undeclared variables.!

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 1/16/2015 14:25'!
% aNodeTestStringOrBlock
	"parent axis"
	(self hasParent
		and: [aNodeTestStringOrBlock asNodeTestBlock value: self parent])
		ifTrue: [^ self newNodeSetWith: self parent]
		ifFalse: [^ self newNodeSet]! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 1/30/2015 19:06'!
%% aNodeTestStringOrBlock
	"ancestor axis"
	| nodeSet nodeTestBlock |

	nodeSet := self newNodeSet.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	self ancestorNodesDo: [:each |
		(nodeTestBlock value: each)
			ifTrue: [nodeSet addLast: each]].
	^ nodeSet sortOrder: XPathReverseDocumentSortOrder new.! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 1/30/2015 19:06'!
%%~ aNodeTestStringOrBlock
	"ancestor-or-self axis"
	| nodeSet nodeTestBlock |

	nodeSet := self newNodeSet.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	(nodeTestBlock value: self)
		ifTrue: [nodeSet addLast: self].
	self ancestorNodesDo: [:each |
		(nodeTestBlock value: each)
			ifTrue: [nodeSet addLast: each]].
	^ nodeSet sortOrder: XPathReverseDocumentSortOrder new.! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 1/30/2015 00:34'!
/ aNodeTestStringOrBlock
	"child axis"
	^ self newNodeSet! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 1/30/2015 00:34'!
// aNodeTestStringOrBlock
	"descendant axis"
	^ self newNodeSet! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 1/30/2015 00:34'!
//~ aNodeTestStringOrBlock
	"descendant-or-self axis"
	(aNodeTestStringOrBlock asNodeTestBlock value: self)
		ifTrue: [^ self newNodeSetWith: self]
		ifFalse: [^ self newNodeSet]! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 1/30/2015 19:06'!
<< aNodeTestStringOrBlock
	"preceding axis"
	| nodeSet nodeTestBlock |

	nodeSet := self newNodeSet.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	self precedingNodesDo: [:each |
		(nodeTestBlock value: each)
			ifTrue: [nodeSet addLast: each]].
	^ nodeSet sortOrder: XPathReverseDocumentSortOrder new.! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 2/10/2015 01:13'!
<<< aNodeTestStringOrBlock
	"preceding-sibling axis"
	| nodeSet nodeTestBlock |

	nodeSet := self newNodeSet.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	self precedingSiblingNodesDo: [:each |
		(nodeTestBlock value: each)
			ifTrue: [nodeSet addLast: each]].
	^ nodeSet sortOrder: XPathLevelReverseDocumentSortOrder new.! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 1/30/2015 18:43'!
>> aNodeTestStringOrBlock
	"following axis"
	| nodeSet nodeTestBlock |

	nodeSet := self newNodeSet.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	self followingNodesDo: [:each |
		(nodeTestBlock value: each)
			ifTrue: [nodeSet addLast: each]].
	^ nodeSet sortOrder: XPathDocumentSortOrder new.! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 2/10/2015 01:12'!
>>> aNodeTestStringOrBlock
	"following-sibling axis"
	| nodeSet nodeTestBlock |

	nodeSet := self newNodeSet.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	self followingSiblingNodesDo: [:each |
		(nodeTestBlock value: each)
			ifTrue: [nodeSet addLast: each]].
	^ nodeSet sortOrder: XPathLevelDocumentSortOrder new.! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 2/3/2015 00:44'!
@ aNodeTestStringOrBlock
	"attribute axis"
	^ self newNodeSet! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 2/3/2015 00:44'!
@@ aNodeTestStringOrBlock
	"namespace axis"
	^ self newNodeSet! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 1/16/2015 14:18'!
allNodesReverseDo: aBlock
	aBlock value: self! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 12/20/2014 20:55'!
asXPathString
	 ^ ''! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 2/9/2015 07:52'!
documentRoot
	| documentRoot |

	documentRoot := self.
	self ancestorNodesDo: [:each | documentRoot := each].
	^ documentRoot.! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 2/4/2015 06:42'!
followingNodesDo: aBlock
	self hasParent
		ifTrue: [| visitedSelf |
			visitedSelf := false.
			self parent nodesDo: [:each |
				visitedSelf
					ifTrue: [each allNodesDo: aBlock]
					ifFalse: [
						each = self
							ifTrue: [visitedSelf := true]]]]! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 2/4/2015 06:42'!
followingSiblingNodesDo: aBlock
	self hasParent
		ifTrue: [| visitedSelf |
			visitedSelf := false.
			self parent nodesDo: [:each |
				visitedSelf
					ifTrue: [aBlock value: each]
					ifFalse: [
						each = self
							ifTrue: [visitedSelf := true]]]]! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 12/30/2014 16:38'!
hasExpandedName
	^ false! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 1/29/2015 00:39'!
isNamespace
	^ false! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 12/30/2014 08:01'!
isPrincipalNode
	^ false! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 12/30/2014 06:49'!
newNodeSet
	^ XPathNodeSet new! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 2/3/2015 01:35'!
newNodeSetWith: aNode
	^ XPathNodeSet with: aNode! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 2/10/2015 20:36'!
occursInDocumentBeforeNode: aNode
	| selfAncestors aNodeAncestors selfLastAncestor aNodeLastAncestor selfAncestorOffset aNodeAncestorOffset |

	self = aNode
		ifTrue: [^ false].

	(self hasParent not
		or: [aNode parent = self])
		ifTrue: [^ true].
	(aNode hasParent not
		or: [self parent = aNode])
		ifTrue: [^ false].
	self parent = aNode parent
		ifTrue: [^ self occursInParentBeforeNode: aNode].

	selfAncestors := OrderedCollection new.
	self ancestorNodesDo: [:each |
		each = aNode
			ifTrue: [^ false].
		selfAncestors addLast: each].

	aNodeAncestors := OrderedCollection new.
	aNode ancestorNodesDo: [:each |
		each = self
			ifTrue: [^ true].
		aNodeAncestors addLast: each].

	selfAncestorOffset := (selfAncestors size - aNodeAncestors size) max: 0.
	selfLastAncestor := selfAncestors at: selfAncestorOffset ifAbsent: [self].
	aNodeAncestorOffset := (aNodeAncestors size - selfAncestors size) max: 0.
	aNodeLastAncestor := aNodeAncestors at: aNodeAncestorOffset ifAbsent: [aNode].
	1
		to: selfAncestors size - selfAncestorOffset
		do: [:i | | selfAncestor aNodeAncestor |
			selfAncestor := selfAncestors at: i + selfAncestorOffset.
			aNodeAncestor := aNodeAncestors at: i + aNodeAncestorOffset.
			selfAncestor = aNodeAncestor
				ifTrue: [^ selfLastAncestor occursInParentBeforeNode: aNodeLastAncestor].

			selfLastAncestor := selfAncestor.
			aNodeLastAncestor := aNodeAncestor].
	^ false.! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 1/30/2015 15:24'!
occursInParentAfterAttribute: anAttribute
	^ true! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 1/30/2015 15:25'!
occursInParentAfterNamespace: aNamespace
	^ true! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 1/30/2015 15:26'!
occursInParentAfterSibling: aNode
	self parent nodesDo: [:each |
		each = aNode
			ifTrue: [^ true].
		each = self
			ifTrue: [^ false]]! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 1/30/2015 15:25'!
occursInParentBeforeNode: aNode
	^ aNode occursInParentAfterSibling: self! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 1/7/2015 23:40'!
parentSize
	self hasParent
		ifTrue: [^ self parent nodes size]
		ifFalse: [^ 1]! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 1/29/2015 00:54'!
position
	self hasParent
		ifTrue: [^ self parent nodes indexOf: self]
		ifFalse: [^ 1]! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 2/4/2015 06:43'!
precedingNodesDo: aBlock
	self hasParent
		ifTrue: [| visitedSelf |
			visitedSelf := false.
			self parent nodes reverseDo: [:each |
				visitedSelf
					ifTrue: [each allNodesReverseDo: aBlock]
					ifFalse: [
						each = self
							ifTrue: [visitedSelf := true]]]]! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 2/4/2015 06:43'!
precedingSiblingNodesDo: aBlock
	self hasParent
		ifTrue: [| visitedSelf |
			visitedSelf := false.
			self parent nodes reverseDo: [:each |
				visitedSelf
					ifTrue: [aBlock value: each]
					ifFalse: [
						each = self
							ifTrue: [visitedSelf := true]]]]! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 1/19/2015 07:47'!
xPath: anXPathString
	^ XPath
		for: anXPathString
		in: self! !

!XMLNode methodsFor: '*XPath-Core-DOM' stamp: 'monty 1/30/2015 02:55'!
~ aNameOrBlock
	"self axis"
	((aNameOrBlock asNodeTestBlock value: self)
		ifTrue: [^ self newNodeSetWith: self]
		ifFalse: [^ self newNodeSet])! !

XMLNode subclass: #XPathNamespaceNode
	instanceVariableNames: 'prefix uri'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathNamespaceNode commentStamp: 'monty 2/10/2015 03:34' prior: 0!
This class models an element namespace mapping as a DOM node for compatibility with the XPath standard.!

!XPathNamespaceNode class methodsFor: 'instance creation' stamp: 'monty 1/26/2015 20:30'!
element: anElement prefix: aPrefix uri: aNamespaceUri
	^ self new
		setElement: anElement
		prefix: aPrefix
		uri: aNamespaceUri! !

!XPathNamespaceNode class methodsFor: 'instance creation' stamp: 'monty 2/10/2015 01:44'!
withXMLNamespaceOnElement: anElement
	^ self
		element: anElement
		prefix: 'xml'
		uri: XMLNamespaceScope xmlNamespaceURI! !

!XPathNamespaceNode methodsFor: 'comparing' stamp: 'monty 1/26/2015 20:31'!
= anObject
	"This is needed because namespace nodes are not part of the DOM
	tree and are created dynamically by XPath, so unless = is defined
	the union of two node sets could contain duplicate namespace nodes
	for the same namespace of the same element"

	self == anObject
		ifTrue: [^ true].

	self class == anObject class
		ifFalse: [^ false].

	"elements don't share namespace nodes according to the spec"
	^ self element = anObject element
		and: [self prefix = anObject prefix
			and: [self uri = anObject uri]].! !

!XPathNamespaceNode methodsFor: 'converting' stamp: 'monty 1/26/2015 20:31'!
asXPathString
	^ self uri! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 12/23/2014 15:22'!
element
	^ parent! !

!XPathNamespaceNode methodsFor: 'namespaces' stamp: 'monty 12/28/2014 06:21'!
expandedName
	^ self localName expandWithNamespaceURI: self namespaceURI! !

!XPathNamespaceNode methodsFor: 'testing' stamp: 'monty 12/30/2014 16:39'!
hasExpandedName
	^ true! !

!XPathNamespaceNode methodsFor: 'testing' stamp: 'monty 12/30/2014 16:58'!
hasPrefix
	^ false! !

!XPathNamespaceNode methodsFor: 'comparing' stamp: 'monty 1/29/2015 20:54'!
hash
	^ self prefix hash bitXor: self uri hash! !

!XPathNamespaceNode methodsFor: 'testing' stamp: 'monty 1/29/2015 00:39'!
isNamespace
	^ true! !

!XPathNamespaceNode methodsFor: 'testing' stamp: 'monty 12/30/2014 08:01'!
isPrincipalNode
	^ true! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 12/27/2014 00:30'!
localName
	^ self prefix! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 12/30/2014 16:39'!
name
	^ self localName! !

!XPathNamespaceNode methodsFor: 'namespaces' stamp: 'monty 2/10/2015 07:10'!
namespaceURI
	"namespace nodes cannot be namespaced.
	the spec says their namespace is null"
	^ ''! !

!XPathNamespaceNode methodsFor: 'private' stamp: 'monty 1/30/2015 15:24'!
occursInParentAfterAttribute: anAttribute
	^ false! !

!XPathNamespaceNode methodsFor: 'private' stamp: 'monty 1/30/2015 15:27'!
occursInParentAfterNamespace: aNamespace
	self parent namespaceNodesDo: [:each |
		each = aNamespace
			ifTrue: [^ true].
		each = self
			ifTrue: [^ false]]! !

!XPathNamespaceNode methodsFor: 'private' stamp: 'monty 1/30/2015 15:25'!
occursInParentBeforeNode: aNode
	^ aNode occursInParentAfterNamespace: self! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 1/29/2015 00:54'!
position
	self hasParent
		ifTrue: [^ self parent namespaceScope prefixMappings indexOfKey: self]
		ifFalse: [^ 1]! !

!XPathNamespaceNode methodsFor: 'namespaces' stamp: 'monty 12/28/2014 06:53'!
prefix
	^ prefix ifNil: [prefix := '']! !

!XPathNamespaceNode methodsFor: 'initialization' stamp: 'monty 1/26/2015 20:30'!
setElement: anElement prefix: aPrefix uri: aUri
	"reuse parent inst var, like in XMLAttribute"
	parent := anElement.
	prefix := aPrefix.
	uri := aUri.! !

!XPathNamespaceNode methodsFor: 'namespaces' stamp: 'monty 1/26/2015 20:32'!
uri
	^ uri ifNil: [uri := '']! !

!XPathNamespaceNode methodsFor: 'printing' stamp: 'monty 1/26/2015 20:31'!
writeXMLOn: aWriter
	aWriter
		writeName:
			(self prefix
				ifEmpty: ['xmlns']
				ifNotEmpty: ['xmlns:', self prefix])
		escapedContentValue: self uri! !

!XMLElement methodsFor: '*XPath-Core-DOM' stamp: 'monty 2/10/2015 01:04'!
@ aNodeTestStringOrBlock
	"attribute axis"
	| nodeSet nodeTestBlock |

	nodeSet := self newNodeSet.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	self hasAttributes
		ifTrue: [
			self attributeNodesDo: [:each |
				(nodeTestBlock value: each)
					ifTrue: [nodeSet addLast: each]]].
	^ nodeSet sortOrder: XPathElementMetaNodeDocumentSortOrder new.! !

!XMLElement methodsFor: '*XPath-Core-DOM' stamp: 'monty 2/10/2015 01:04'!
@@ aNodeTestStringOrBlock
	"namespace axis"
	| nodeSet nodeTestBlock |

	nodeSet := self newNodeSet.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	self hasNamespaceNodes
		ifTrue: [
			self namespaceNodesDo: [:each |
				(nodeTestBlock value: each)
					ifTrue: [nodeSet addLast: each]]].
	^ nodeSet sortOrder: XPathElementMetaNodeDocumentSortOrder new.! !

!XMLElement methodsFor: '*XPath-Core-DOM' stamp: 'monty 12/30/2014 16:39'!
hasExpandedName
	^ true! !

!XMLElement methodsFor: '*XPath-Core-DOM' stamp: 'monty 2/9/2015 22:23'!
hasNamespaceNodes
	"elements have at least one node for the default xml namespace"
	^ self usesNamespaces! !

!XMLElement methodsFor: '*XPath-Core-DOM' stamp: 'monty 12/30/2014 08:01'!
isPrincipalNode
	^ true! !

!XMLElement methodsFor: '*XPath-Core-DOM' stamp: 'monty 2/10/2015 20:24'!
namespaceNodesDo: aBlock
	"every element has a node for the default xml namespace.
	if it isn't explicitly defined, then it's first in order"
	(self hasNamespaces
		and: [self namespaceScope includesPrefix: 'xml'])
		ifFalse: [aBlock value: (XPathNamespaceNode withXMLNamespaceOnElement: self)].

	self hasNamespaces
		ifTrue: [
			self namespaceScope prefixesAndURIsDo: [:prefix :uri |
				aBlock value:
					(XPathNamespaceNode
						element: self
						prefix: prefix
						uri: uri)]].! !

!Number class methodsFor: '*XPath-Core' stamp: 'monty 12/22/2014 18:20'!
xPathNewFrom: anObject
	^ anObject asXPathNumber! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 07:59'!
/!!=/ anObject
	^ anObject xPathNotEqualsNumber: self! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 01:59'!
/*/ anObject
	^ self asXPathNumber * anObject asXPathNumber! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 01:59'!
/+/ anObject
	^ self asXPathNumber + anObject asXPathNumber! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 01:59'!
/-/ anObject
	^ self asXPathNumber - anObject asXPathNumber! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 02:01'!
/// anObject
	^ self asXPathNumber / anObject asXPathNumber! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 1/7/2015 23:22'!
/</ anObject
	^ anObject xPathGreaterThanNumber: self! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 07:58'!
/<=/ anObject
	^ (anObject xPathGreaterThanNumber: self)
		or: [anObject xPathEqualsNumber: self]! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 1/7/2015 23:22'!
/=/ anObject
	^ anObject xPathEqualsNumber: self! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 07:59'!
/>/ anObject
	^ anObject xPathLessThanNumber: self! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 07:58'!
/>=/ anObject
	^ (anObject xPathLessThanNumber: self)
		or: [anObject xPathEqualsNumber: self]! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 02:00'!
/\\/ anObject
	^ self asXPathNumber \\ anObject asXPathNumber! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 12/22/2014 18:16'!
asXPathBoolean
	^ (self isZero or: [self isNaN]) not! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 12/23/2014 14:40'!
asXPathNumber
	^ self asFloat! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 2/10/2015 07:17'!
asXPathString
	self isNaN
		ifTrue: [^ 'NaN'].
	self isZero
		ifTrue: [^ '0'].
	self isInfinite
		ifTrue: [
			self < 0
				ifTrue: [^ '-Infinity']
				ifFalse: [^ 'Infinity']]
		ifFalse: [| stream |
			"printString does not return decimal strings on Gemstone"
			stream := (String new: 10) writeStream.
			self
				printOn: stream
				base: 10.
			^ stream contents].! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 07:54'!
xPathEqualsBoolean: aBoolean
	^ self asXPathBoolean = aBoolean! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 09:20'!
xPathEqualsNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each | self = each asXPathString asXPathNumber]! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 12/24/2014 02:39'!
xPathEqualsNumber: aNumber
	^ self = aNumber! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 12/24/2014 02:46'!
xPathEqualsString: aString
	^ self = aString asXPathNumber! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 12/24/2014 02:48'!
xPathGreaterThanBoolean: aBoolean
	^ self > aBoolean asXPathNumber! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 09:06'!
xPathGreaterThanNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each | self > each asXPathString asXPathNumber]! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 12/24/2014 02:39'!
xPathGreaterThanNumber: aNumber
	^ self > aNumber! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 12/24/2014 02:48'!
xPathGreaterThanString: aString
	^ self > aString asXPathNumber! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 09:00'!
xPathLessThanBoolean: aBoolean
	^ self < aBoolean asXPathNumber! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 09:20'!
xPathLessThanNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each | self < each asXPathString asXPathNumber]! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 07:57'!
xPathLessThanNumber: aNumber
	^ self < aNumber! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 07:57'!
xPathLessThanString: aString
	^ self < aString asXPathNumber! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 07:54'!
xPathNotEqualsBoolean: aBoolean
	^ self asXPathBoolean ~= aBoolean! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 09:06'!
xPathNotEqualsNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each | self ~= each asXPathString asXPathNumber]! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 07:54'!
xPathNotEqualsNumber: aNumber
	^ self ~= aNumber! !

!Number methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 07:55'!
xPathNotEqualsString: aString
	^ self ~= aString asXPathNumber! !

!XMLAttribute methodsFor: '*XPath-Core-DOM' stamp: 'monty 12/20/2014 20:55'!
asXPathString
	^ self value! !

!XMLAttribute methodsFor: '*XPath-Core-DOM' stamp: 'monty 12/30/2014 16:39'!
hasExpandedName
	^ true! !

!XMLAttribute methodsFor: '*XPath-Core-DOM' stamp: 'monty 12/30/2014 08:01'!
isPrincipalNode
	^ true! !

!XMLAttribute methodsFor: '*XPath-Core-DOM' stamp: 'monty 1/30/2015 15:24'!
occursInParentAfterAttribute: anAttribute
	self element attributeNodesDo: [:each |
		each = anAttribute
			ifTrue: [^ true]].
	^ false.! !

!XMLAttribute methodsFor: '*XPath-Core-DOM' stamp: 'monty 1/30/2015 15:25'!
occursInParentBeforeNode: aNode
	^ aNode occursInParentAfterAttribute: self! !

!XMLAttribute methodsFor: '*XPath-Core-DOM' stamp: 'monty 1/29/2015 00:55'!
position
	self hasParent
		ifTrue: [^ self parent attributeNodes indexOf: self]
		ifFalse: [^ 1]! !

!String class methodsFor: '*XPath-Core' stamp: 'monty 12/22/2014 18:20'!
xPathNewFrom: anObject
	^ anObject asXPathString! !

!String methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 08:02'!
/!!=/ anObject
	^ anObject xPathNotEqualsString: self! !

!String methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 01:58'!
/*/ anObject
	^ self asXPathNumber * anObject asXPathNumber! !

!String methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 01:59'!
/+/ anObject
	^ self asXPathNumber + anObject asXPathNumber! !

!String methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 02:00'!
/-/ anObject
	^ self asXPathNumber - anObject asXPathNumber! !

!String methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 02:01'!
/// anObject
	^ self asXPathNumber / anObject asXPathNumber! !

!String methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 08:00'!
/</ anObject
	^ anObject xPathGreaterThanString: self! !

!String methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 08:01'!
/<=/ anObject
	^ (anObject xPathGreaterThanString: self)
		or: [anObject xPathEqualsString: self]! !

!String methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 08:02'!
/=/ anObject
	^ anObject xPathEqualsString: self! !

!String methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 08:01'!
/>/ anObject
	^ anObject xPathLessThanString: self! !

!String methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 08:01'!
/>=/ anObject
	^ (anObject xPathLessThanString: self)
		or: [anObject xPathEqualsString: self]! !

!String methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 02:00'!
/\\/ anObject
	^ self asXPathNumber \\ anObject asXPathNumber! !

!String methodsFor: '*XPath-Core' stamp: 'monty 1/10/2015 06:06'!
asNodeTestBlock
	^ (XPathNodeTestParser
		on: self
		for: XPathStringNodeTestParserHandler new) parse! !

!String methodsFor: '*XPath-Core' stamp: 'monty 12/17/2014 14:19'!
asXPath
	^ XPath for: self! !

!String methodsFor: '*XPath-Core' stamp: 'monty 12/20/2014 14:36'!
asXPathBoolean
	^ self notEmpty! !

!String methodsFor: '*XPath-Core' stamp: 'monty 12/24/2014 19:19'!
asXPathNumber
	^ [Float readFrom: self readStream]
		on: Error
		do: [:error | Float nan]! !

!String methodsFor: '*XPath-Core' stamp: 'monty 12/20/2014 15:06'!
asXPathString
	^ self! !

!String methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 08:03'!
xPathEqualsBoolean: aBoolean
	^ self asXPathBoolean = aBoolean! !

!String methodsFor: '*XPath-Core' stamp: 'monty 12/24/2014 19:14'!
xPathEqualsNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each | self = each asXPathString]! !

!String methodsFor: '*XPath-Core' stamp: 'monty 12/24/2014 02:54'!
xPathEqualsNumber: aNumber
	^ self asXPathNumber = aNumber! !

!String methodsFor: '*XPath-Core' stamp: 'monty 12/24/2014 02:52'!
xPathEqualsString: aString
	^ self = aString! !

!String methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 08:04'!
xPathGreaterThanBoolean: aBoolean
	^ self asXPathNumber > aBoolean asXPathNumber! !

!String methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 09:19'!
xPathGreaterThanNodeSet: aNodeSet
	| number |
	
	number := self asXPathNumber.
	^ aNodeSet anySatisfy: [:each | number > each asXPathString asXPathNumber].! !

!String methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 08:05'!
xPathGreaterThanNumber: aNumber
	^ self asXPathNumber > aNumber! !

!String methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 08:04'!
xPathGreaterThanString: aString
	^ self asXPathNumber > aString asXPathNumber! !

!String methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 08:05'!
xPathLessThanBoolean: aBoolean
	^ self asXPathNumber < aBoolean asXPathNumber! !

!String methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 09:19'!
xPathLessThanNodeSet: aNodeSet
	| number |
	
	number := self asXPathNumber.
	^ aNodeSet anySatisfy: [:each | number < each asXPathString asXPathNumber].! !

!String methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 08:06'!
xPathLessThanNumber: aNumber
	^ self asXPathNumber < aNumber! !

!String methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 08:06'!
xPathLessThanString: aString
	^ self asXPathNumber < aString asXPathNumber! !

!String methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 08:03'!
xPathNotEqualsBoolean: aBoolean
	^ self asXPathBoolean ~= aBoolean! !

!String methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 08:02'!
xPathNotEqualsNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each | self ~= each asXPathString]! !

!String methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 08:02'!
xPathNotEqualsNumber: aNumber
	^ self asXPathNumber ~= aNumber! !

!String methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 08:02'!
xPathNotEqualsString: aString
	^ self ~= aString! !

!PositionableStream methodsFor: '*XPath-Core-Streams' stamp: 'monty 1/14/2015 03:20'!
asXPathReadStreamAdapter
	^ XPathReadStreamAdapter on: self! !

!BlockClosure methodsFor: '*XPath-Core' stamp: 'monty 12/31/2014 08:17'!
asNodeTestBlock
	^ self! !

Collection subclass: #XPathFunctionSet
	instanceVariableNames: 'functionsByName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathFunctionSet commentStamp: 'monty 2/10/2015 03:01' prior: 0!
A set for XPath functions. Supports set composition with + and - and lookup of functions by name.
!

!XPathFunctionSet class methodsFor: 'instance creation' stamp: 'monty 2/12/2015 20:26'!
default
	^ XPathBooleanFunction +
		XPathCeilingFunction +
		XPathConcatFunction +
		XPathContainsFunction +
		XPathCountFunction +
		XPathEndsWithFunction +
		XPathFalseFunction +
		XPathFloorFunction +
		XPathLangFunction +
		XPathLocalNameFunction +
		XPathNameFunction +
		XPathNamespaceURIFunction +
		XPathNormalizeSpaceFunction +
		XPathNotFunction +
		XPathNumberFunction +
		XPathRoundFunction +
		XPathStartsWithFunction +
		XPathStringFunction +
		XPathStringLengthFunction +
		XPathSubstringAfterFunction +
		XPathSubstringBeforeFunction +
		XPathSubstringFunction +
		XPathSumFunction +
		XPathTranslateFunction +
		XPathTrueFunction! !

!XPathFunctionSet class methodsFor: 'instance creation' stamp: 'monty 1/18/2015 15:23'!
new
	^ self new: 15! !

!XPathFunctionSet class methodsFor: 'instance creation' stamp: 'monty 12/27/2014 17:02'!
new: aCapacity
	^ self basicNew initialize: aCapacity! !

!XPathFunctionSet class methodsFor: 'instance creation' stamp: 'monty 1/19/2015 15:16'!
newFrom: aCollection
	"for portability"
	^ self withAll: aCollection! !

!XPathFunctionSet methodsFor: 'composition' stamp: 'monty 12/27/2014 17:09'!
+ aFunctionOrFunctionSet
	^ aFunctionOrFunctionSet asFunctionSetWithFunctions: self! !

!XPathFunctionSet methodsFor: 'composition' stamp: 'monty 12/29/2014 21:31'!
- aFunctionOrFunctionSet
	^ aFunctionOrFunctionSet asFunctionSetSubtractedFromFunctions: self! !

!XPathFunctionSet methodsFor: 'comparing' stamp: 'monty 12/29/2014 21:18'!
= aFunctionSet
	self == aFunctionSet
		ifTrue: [^ true].

	(self class == aFunctionSet class
		and: [self size = aFunctionSet size])
		ifFalse: [^ false].

	^ self allSatisfy: [:each | aFunctionSet includes: each].! !

!XPathFunctionSet methodsFor: 'accessing' stamp: 'monty 12/27/2014 16:56'!
add: aFunction
	^ functionsByName
		at: aFunction functionName
		put: aFunction! !

!XPathFunctionSet methodsFor: 'converting' stamp: 'monty 1/15/2015 09:51'!
asFunctionSet
	^ self! !

!XPathFunctionSet methodsFor: 'converting' stamp: 'monty 1/15/2015 09:53'!
asFunctionSetSubtractedFromFunction: aFunction
	^ aFunction asFunctionSet copyWithoutAll: self! !

!XPathFunctionSet methodsFor: 'converting' stamp: 'monty 12/29/2014 21:31'!
asFunctionSetSubtractedFromFunctions: aFunctionSet
	^ aFunctionSet copyWithoutAll: self! !

!XPathFunctionSet methodsFor: 'converting' stamp: 'monty 12/29/2014 21:22'!
asFunctionSetWithFunction: aFunction
	^ self copyWith: aFunction! !

!XPathFunctionSet methodsFor: 'converting' stamp: 'monty 1/15/2015 09:58'!
asFunctionSetWithFunctions: aFunctionSet
	", is not portable for non-sequenceable collections"
	^ self copy
		addAll: aFunctionSet;
		yourself! !

!XPathFunctionSet methodsFor: 'enumerating' stamp: 'monty 12/27/2014 16:59'!
do: aBlock
	functionsByName valuesDo: aBlock! !

!XPathFunctionSet methodsFor: 'accessing' stamp: 'monty 2/10/2015 19:11'!
functionNamed: aFunctionName
	^  functionsByName at: aFunctionName! !

!XPathFunctionSet methodsFor: 'accessing' stamp: 'monty 2/10/2015 19:12'!
functionNamed: aFunctionName ifAbsent: aBlock
	^  functionsByName
		at: aFunctionName
		ifAbsent: aBlock! !

!XPathFunctionSet methodsFor: 'private' stamp: 'monty 1/19/2015 17:08'!
functionsByName
	^ functionsByName! !

!XPathFunctionSet methodsFor: 'comparing' stamp: 'monty 12/29/2014 21:19'!
hash
	^ functionsByName hash! !

!XPathFunctionSet methodsFor: 'testing' stamp: 'monty 12/27/2014 17:10'!
includes: aFunction
	^ (functionsByName
		at: aFunction functionName
		ifAbsent: [^ false]) == aFunction! !

!XPathFunctionSet methodsFor: 'testing' stamp: 'monty 2/10/2015 19:15'!
includesFunctionNamed: aName
	^ functionsByName includesKey: aName! !

!XPathFunctionSet methodsFor: 'initialization' stamp: 'monty 12/27/2014 17:01'!
initialize: aCapacity
	functionsByName := Dictionary new: aCapacity! !

!XPathFunctionSet methodsFor: 'copying' stamp: 'monty 12/27/2014 03:55'!
postCopy
	functionsByName := functionsByName copy! !

!XPathFunctionSet methodsFor: 'accessing' stamp: 'monty 12/27/2014 16:58'!
remove: aFunction ifAbsent: aBlock
	^ functionsByName
		removeKey: aFunction functionName
		ifAbsent: aBlock! !

!XPathFunctionSet methodsFor: 'accessing' stamp: 'monty 12/27/2014 03:59'!
size
	^ functionsByName size! !

!XMLDocument methodsFor: '*XPath-Core-DOM' stamp: 'monty 2/4/2015 06:44'!
documentRoot
	^ self! !

!XMLDocument methodsFor: '*XPath-Core-DOM' stamp: 'monty 1/30/2015 15:26'!
occursInParentAfterAttribute: aNode
	^ false! !

!XMLDocument methodsFor: '*XPath-Core-DOM' stamp: 'monty 1/30/2015 15:26'!
occursInParentAfterNamespace: aNode
	^ false! !

!XMLDocument methodsFor: '*XPath-Core-DOM' stamp: 'monty 1/30/2015 15:26'!
occursInParentAfterSibling: aNode
	^ false! !

!Boolean class methodsFor: '*XPath-Core' stamp: 'monty 12/22/2014 18:20'!
xPathNewFrom: anObject
	^ anObject asXPathBoolean! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 07:38'!
/!!=/ anObject
	^ anObject xPathNotEqualsBoolean: self! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 01:58'!
/*/ anObject
	^ self asXPathNumber * anObject asXPathNumber! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 01:59'!
/+/ anObject
	^ self asXPathNumber + anObject asXPathNumber! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 01:59'!
/-/ anObject
	^ self asXPathNumber - anObject asXPathNumber! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 02:00'!
/// anObject
	^ self asXPathNumber / anObject asXPathNumber! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 1/7/2015 23:22'!
/</ anObject
	^ anObject xPathGreaterThanBoolean: self! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 07:37'!
/<=/ anObject
	^ (anObject xPathGreaterThanBoolean: self)
		or: [anObject xPathEqualsBoolean: self]! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 1/7/2015 23:22'!
/=/ anObject
	^ anObject xPathEqualsBoolean: self! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 07:37'!
/>/ anObject
	^ anObject xPathLessThanBoolean: self! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 07:38'!
/>=/ anObject
	^ (anObject xPathLessThanBoolean: self)
		or: [anObject xPathEqualsBoolean: self]! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 02:00'!
/\\/ anObject
	^ self asXPathNumber \\ anObject asXPathNumber! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 12/20/2014 14:36'!
asXPathBoolean
	^ self! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 12/20/2014 15:00'!
asXPathNumber
	self subclassResponsibility! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 12/20/2014 15:03'!
asXPathString
	self subclassResponsibility! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 12/24/2014 06:16'!
xPathEqualsBoolean: aBoolean
	^ self = aBoolean! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 12/25/2014 15:41'!
xPathEqualsNodeSet: aNodeSet
	^ self = aNodeSet asXPathBoolean! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 12/24/2014 06:16'!
xPathEqualsNumber: aNumber
	^ self = aNumber asXPathBoolean! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 12/24/2014 06:17'!
xPathEqualsString: aString
	^ self = aString asXPathBoolean! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 09:17'!
xPathGreaterThanBoolean: aBoolean
	^ self asXPathNumber > aBoolean asXPathNumber! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 09:18'!
xPathGreaterThanNodeSet: aNodeSet
	^ self asXPathNumber > aNodeSet asXPathBoolean asXPathNumber! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 07:42'!
xPathGreaterThanNumber: aNumber
	^ self asXPathNumber > aNumber asXPathNumber! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 07:46'!
xPathGreaterThanString: aString
	^ self asXPathNumber > aString asXPathNumber! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 09:00'!
xPathLessThanBoolean: aBoolean
	^ self asXPathNumber < aBoolean asXPathNumber! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 09:18'!
xPathLessThanNodeSet: aNodeSet
	^ self asXPathNumber < aNodeSet asXPathBoolean asXPathNumber! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 07:46'!
xPathLessThanNumber: aNumber
	^ self asXPathNumber < aNumber asXPathNumber! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 07:46'!
xPathLessThanString: aString
	^ self asXPathNumber < aString asXPathNumber! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 07:36'!
xPathNotEqualsBoolean: aBoolean
	^ self ~= aBoolean! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 07:37'!
xPathNotEqualsNodeSet: aNodeSet
	^ self ~= aNodeSet asXPathBoolean! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 07:36'!
xPathNotEqualsNumber: aNumber
	^ self ~= aNumber asXPathBoolean! !

!Boolean methodsFor: '*XPath-Core' stamp: 'monty 1/13/2015 07:35'!
xPathNotEqualsString: aString
	^ self ~= aString asXPathBoolean! !

!XMLString methodsFor: '*XPath-Core-DOM' stamp: 'monty 12/20/2014 20:55'!
asXPathString
	^ self string! !

!Float methodsFor: '*XPath-Core' stamp: 'monty 12/23/2014 14:40'!
asXPathNumber
	^ self! !

!False methodsFor: '*XPath-Core' stamp: 'monty 12/22/2014 18:17'!
asXPathNumber
	^ 0.0! !

!False methodsFor: '*XPath-Core' stamp: 'monty 12/20/2014 15:03'!
asXPathString
	^ 'false'! !

!True methodsFor: '*XPath-Core' stamp: 'monty 12/22/2014 18:17'!
asXPathNumber
	^ 1.0! !

!True methodsFor: '*XPath-Core' stamp: 'monty 12/20/2014 15:03'!
asXPathString
	^ 'true'! !

!XMLPI methodsFor: '*XPath-Core-DOM' stamp: 'monty 12/20/2014 20:55'!
asXPathString
	^ self data! !

!XMLPI methodsFor: '*XPath-Core-DOM' stamp: 'monty 12/28/2014 06:21'!
expandedName
	^ self localName expandWithNamespaceURI: self namespaceURI! !

!XMLPI methodsFor: '*XPath-Core-DOM' stamp: 'monty 12/30/2014 16:39'!
hasExpandedName
	^ true! !

!XMLPI methodsFor: '*XPath-Core-DOM' stamp: 'monty 12/30/2014 16:58'!
hasPrefix
	^ false! !

!XMLPI methodsFor: '*XPath-Core-DOM' stamp: 'monty 12/27/2014 00:30'!
localName
	^ self target! !

!XMLPI methodsFor: '*XPath-Core-DOM' stamp: 'monty 12/30/2014 16:40'!
name
	^ self localName! !

!XMLPI methodsFor: '*XPath-Core-DOM' stamp: 'monty 12/28/2014 06:21'!
namespaceURI
	"The spec says the namespace URI part of an expanded name is null"
	^ ''! !

XMLNodeList subclass: #XPathNodeSet
	instanceVariableNames: 'set sortOrder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathNodeSet commentStamp: 'monty 2/10/2015 03:47' prior: 0!
An XPath node set is an ordered node list that has no duplicates. Node sets produced by XPath expression evaluation will be sorted in either document order or reverse document order.!

!XPathNodeSet class methodsFor: 'private' stamp: 'monty 1/15/2015 13:52'!
errorCannotConvert: anObject
	XPathTypeException
		formatSignal: 'Cannot convert object of class {1} to node set'
		with: anObject class name! !

!XPathNodeSet class methodsFor: 'instance creation' stamp: 'monty 1/15/2015 13:51'!
xPathNewFrom: anObject
	"no conversions are specified from other types to node sets"
	(anObject isKindOf: XPathNodeSet)
		ifFalse: [self errorCannotConvert: anObject].
	^ anObject.! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 2/3/2015 03:45'!
% aNodeTestStringOrBlock
	"parent axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				parentAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first % aNodeTestStringOrBlock].
	^ self.! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 2/3/2015 03:45'!
%% aNodeTestStringOrBlock
	"ancestor axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				ancestorAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first %% aNodeTestStringOrBlock].
	^ self.! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 2/3/2015 03:45'!
%%~ aNodeTestStringOrBlock
	"ancestor-or-self axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				ancestorOrSelfAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first %%~ aNodeTestStringOrBlock].
	^ self.! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 2/3/2015 03:46'!
/ aNodeTestStringOrBlock
	"child axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				childAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first / aNodeTestStringOrBlock].
	^ self.! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 07:01'!
/!!=/ anObject
	^ anObject xPathNotEqualsNodeSet: self! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 02:03'!
/*/ anObject
	^ self asXPathNumber * anObject asXPathNumber! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 02:03'!
/+/ anObject
	^ self asXPathNumber + anObject asXPathNumber! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 02:03'!
/-/ anObject
	^ self asXPathNumber - anObject asXPathNumber! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 2/3/2015 03:46'!
// aNodeTestStringOrBlock
	"descendant axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				descendantAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first // aNodeTestStringOrBlock].
	^ self.! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 02:03'!
/// anObject
	^ self asXPathNumber / anObject asXPathNumber! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 2/3/2015 03:46'!
//~ aNodeTestStringOrBlock
	"descendant-or-self axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				descendantOrSelfAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first //~ aNodeTestStringOrBlock].
	^ self.! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 07:02'!
/</ anObject
	^ anObject xPathGreaterThanNodeSet: self! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 07:03'!
/<=/ anObject
	^ (anObject xPathGreaterThanNodeSet: self)
		or: [anObject xPathEqualsNodeSet: self]! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 07:01'!
/=/ anObject
	^ anObject xPathEqualsNodeSet: self! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 07:02'!
/>/ anObject
	^ anObject xPathLessThanNodeSet: self! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 07:02'!
/>=/ anObject
	^ (anObject xPathLessThanNodeSet: self)
		or: [anObject xPathEqualsNodeSet: self]! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 02:03'!
/\\/ anObject
	^ self asXPathNumber \\ anObject asXPathNumber! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 2/3/2015 03:46'!
<< aNodeTestStringOrBlock
	"preceding axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				precedingAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first << aNodeTestStringOrBlock].
	^ self.! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 2/3/2015 03:46'!
<<< aNodeTestStringOrBlock
	"preceding-sibling axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				precedingSiblingAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first <<< aNodeTestStringOrBlock].
	^ self.! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 2/3/2015 03:46'!
>> aNodeTestStringOrBlock
	"following axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				followingAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first >> aNodeTestStringOrBlock].
	^ self.! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 2/3/2015 03:46'!
>>> aNodeTestStringOrBlock
	"following-sibling axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				followingSiblingAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first >>> aNodeTestStringOrBlock].
	^ self.! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 2/3/2015 03:49'!
?? aFilterBlockOrInteger
	"filters with filter block or index"
	| nodeSet |

	nodeSet := self copyEmpty.
	aFilterBlockOrInteger isNumber
		ifTrue: [
			(self
				at: aFilterBlockOrInteger rounded
				ifAbsent: [nil])
				ifNotNil: [:node | nodeSet addLast: node].
			^ nodeSet].

	1 to: self size do: [:i | | node result |
		node := self at: i.
		(result := aFilterBlockOrInteger value: node value: i) isNumber
			ifTrue: [
				result rounded = i
					ifTrue: [nodeSet addLast: node]]
			ifFalse: [
				result asXPathBoolean
					ifTrue: [nodeSet addLast: node]]].

	^ nodeSet sortOrderFrom: self.! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 2/3/2015 03:46'!
@ aNodeTestStringOrBlock
	"attribute axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				attributeAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first @ aNodeTestStringOrBlock].
	^ self.! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 2/3/2015 03:46'!
@@ aNodeTestStringOrBlock
	"namespace axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				namespaceAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first @@ aNodeTestStringOrBlock].
	^ self.! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 2/3/2015 23:31'!
afterAdding: aNode at: anIndex
	| oldSize |

	oldSize := self set size.
	((self set
		add: aNode;
		size) > oldSize)
		ifFalse: [self movedNode: aNode to: anIndex].
	sortOrder := nil.
	super
		afterAdding: aNode
		at: anIndex.! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 2/3/2015 23:33'!
afterAddingLast: aNode
	| oldSize |

	oldSize := self set size.
	(self set
		add: aNode;
		size) > oldSize
		ifFalse: [self movedNode: aNode to: oldSize].
	sortOrder := nil.
	super afterAddingLast: aNode.! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/25/2015 13:21'!
afterRemoving: aNode
	self set remove: aNode.
	sortOrder := nil.
	super afterRemoving: aNode.! !

!XPathNodeSet methodsFor: 'converting' stamp: 'monty 12/20/2014 20:40'!
asXPathBoolean
	^ self notEmpty! !

!XPathNodeSet methodsFor: 'converting' stamp: 'monty 12/20/2014 20:40'!
asXPathNumber
	^ self asXPathString asXPathNumber! !

!XPathNodeSet methodsFor: 'converting' stamp: 'monty 12/25/2014 04:42'!
asXPathString
	^ (self firstInDocumentOrder ifNil: ['']) asXPathString! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 2/10/2015 21:28'!
copy
	^ super copy sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'accessing' stamp: 'monty 2/3/2015 01:24'!
firstInDocumentOrder
	^ self sortOrder firstInDocumentOrderFrom: self! !

!XPathNodeSet methodsFor: 'testing' stamp: 'monty 1/16/2015 05:26'!
includes: aNode
	^ self set includes: aNode! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 2/9/2015 01:31'!
movedNode: aNode to: anIndex
	| i |

	(i :=
		self
			indexOf: aNode
			otherThan: anIndex) > 0
		ifTrue: [
			"since a node is just being moved, the collection
			is changed directly without notifying observers"
			collection removeAt: i]! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 2/3/2015 03:49'!
reject: aBlock
	^ (super reject: aBlock) sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 2/3/2015 02:49'!
reverseInPlace
	self
		reverseInPlaceFrom: 1
		to: collection size! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 2/3/2015 02:49'!
reverseInPlaceFrom: aStart to: anEnd
	| start end |

	start := aStart.
	end := anEnd.
	[start < end]
		whileTrue: [
			self swap: start with: end.
			start := start + 1.
			end := end - 1].! !

!XPathNodeSet methodsFor: 'sorting' stamp: 'monty 2/8/2015 03:00'!
reverseSort
	self sortOrder reverseDocumentOrderSort: self! !

!XPathNodeSet methodsFor: 'sorting' stamp: 'monty 2/10/2015 21:42'!
reverseSorted
	^ self copy reverseSort! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 2/3/2015 03:49'!
select: aBlock
	^ (super select: aBlock) sortOrderFrom: self! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/18/2015 06:06'!
set
	"IdentitySet is not used because namespace nodes implement ="
	^ set ifNil: [set := Set new: 5]! !

!XPathNodeSet methodsFor: 'sorting' stamp: 'monty 1/26/2015 19:01'!
sort
	self sortOrder documentOrderSort: self! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 2/10/2015 01:12'!
sortOrder
	sortOrder
		ifNil: [
			self size > 1
				ifTrue: [sortOrder := XPathUnknownSortOrder new]
				ifFalse: [sortOrder := XPathLevelDocumentSortOrder new]].
	^ sortOrder.! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/26/2015 17:48'!
sortOrder: aSortOrder
	sortOrder := aSortOrder! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 2/3/2015 03:50'!
sortOrderFrom: aNodeSet
	sortOrder := aNodeSet sortOrder copy! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 07:04'!
xPathEqualsBoolean: aBoolean
	^ self asXPathBoolean = aBoolean! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 02:08'!
xPathEqualsNodeSet: aNodeSet
	| stringValues |

	stringValues := Set new: self size.
	self do: [:each | stringValues add: each asXPathString].
	^ aNodeSet anySatisfy: [:node | stringValues includes: node stringValue].! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 09:14'!
xPathEqualsNumber: aNumber
	^ self anySatisfy: [:each | each asXPathString asXPathNumber = aNumber]! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 12/25/2014 04:29'!
xPathEqualsString: aString
	^ self anySatisfy: [:each | each asXPathString = aString]! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 12/25/2014 15:34'!
xPathGreaterThanBoolean: aBoolean
	^ self asXPathBoolean asXPathNumber > aBoolean asXPathNumber! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 09:14'!
xPathGreaterThanNodeSet: aNodeSet
	| least |

	aNodeSet do: [:each | | number |
		number := each asXPathString asXPathNumber.
		(least isNil
			or: [number < least])
			ifTrue: [least := number]].
	^ least notNil
		and: [self anySatisfy: [:each | each asXPathString asXPathNumber > least]].! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 09:15'!
xPathGreaterThanNumber: aNumber
	^ self anySatisfy: [:each | each asXPathString asXPathNumber > aNumber]! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 09:22'!
xPathGreaterThanString: aString
	| number |

	number := aString asXPathNumber.
	^ self anySatisfy: [:each | each asXPathString asXPathNumber > number]! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 09:11'!
xPathLessThanBoolean: aBoolean
	^ self asXPathBoolean asXPathNumber < aBoolean asXPathNumber! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 09:12'!
xPathLessThanNodeSet: aNodeSet
	| greatest |

	aNodeSet do: [:each | | number |
		number := each asXPathString asXPathNumber.
		(greatest isNil
			or: [number > greatest])
			ifTrue: [greatest := number]].
	^ greatest notNil
		and: [self anySatisfy: [:each | each asXPathString asXPathNumber < greatest]].! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 09:22'!
xPathLessThanNumber: aNumber
	^ self anySatisfy: [:each | each asXPathString asXPathNumber < aNumber]! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 07:23'!
xPathLessThanString: aString
	| number |

	number := aString asXPathNumber.
	^ self anySatisfy: [:each | each asXPathNumber < number]! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 07:00'!
xPathNotEqualsBoolean: aBoolean
	^ self asXPathBoolean ~= aBoolean! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 07:05'!
xPathNotEqualsNodeSet: aNodeSet
	| stringValues |

	stringValues := Set new: self size.
	self do: [:each | stringValues add: each asXPathString].
	^ aNodeSet anySatisfy: [:node | (stringValues includes: node stringValue) not].! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 09:21'!
xPathNotEqualsNumber: aNumber
	^ self anySatisfy: [:each | each asXPathString asXPathNumber ~= aNumber]! !

!XPathNodeSet methodsFor: 'operators' stamp: 'monty 1/13/2015 06:59'!
xPathNotEqualsString: aString
	^ self anySatisfy: [:each | each asXPathString ~= aString]! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 1/15/2015 14:48'!
| aNodeSet
	^ self copy
		addAll: aNodeSet;
		sort! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 2/3/2015 03:45'!
~ aNodeTestStringOrBlock
	"self axis"
	self size > 1
		ifTrue: [
			^ self sortOrder
				selfAxisOn: self
				select: aNodeTestStringOrBlock asNodeTestBlock].
	self size = 1
		ifTrue: [^ self first ~ aNodeTestStringOrBlock].
	^ self.! !

!XMLNodeWithChildren methodsFor: '*XPath-Core-DOM' stamp: 'monty 1/16/2015 14:20'!
allNodesReverseDo: aBlock
	self hasChildren
		ifTrue: [self nodes reverseDo: [:each | each allNodesReverseDo: aBlock]].
	aBlock value: self.! !

!Object class methodsFor: '*XPath-Core' stamp: 'monty 1/20/2015 19:23'!
xPathNewFrom: anObject
	^ anObject! !

Object subclass: #XPath
	instanceVariableNames: 'compiler xPathSource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core'!

XPath class
	instanceVariableNames: 'compiledXPathCache'!

!XPath commentStamp: 'monty 2/11/2015 18:32' prior: 0!
This class evaluates XPath expressions in the context of XMLNodes using optional context objects to control evaluation. It supports all XPath 1.0 syntax.

This is the usage:
	path := XPath for: anXPathString.
	result := path in: aNode.

or with one message:
	result := XPath for: anXPathString in: aNode.

A custom context can be set this way:
	path := XPath for: anXPathString.
	path
		in: aNode
		context:
			(XPathContext new
				variableAt: 'name' put: 'value';
				yourself)

or with one message:
	XPath
		for: anXPathString
		in: aNode
		context:
			(XPathContext new
				variableAt: 'name' put: 'value';
				yourself).

Compiled XPaths are cached for performance.!

XPath class
	instanceVariableNames: 'compiledXPathCache'!

!XPath class methodsFor: 'accessing' stamp: 'monty 2/8/2015 19:29'!
clearCompiledXPathCache
	"self clearCompiledXPathCache"
	compiledXPathCache ifNotNil: [compiledXPathCache clear]! !

!XPath class methodsFor: 'accessing' stamp: 'monty 2/8/2015 19:30'!
compiledXPathCache
	^ compiledXPathCache
		ifNil: [compiledXPathCache := XMLKeyValueCache maxSize: 256]! !

!XPath class methodsFor: 'private' stamp: 'monty 12/17/2014 23:01'!
compiledXPathCacheAt: anXPathString ifAbsentPut: aBlock
	^ self compiledXPathCache
		at: anXPathString
		ifAbsentPut: aBlock! !

!XPath class methodsFor: 'instance creation' stamp: 'monty 2/9/2015 20:21'!
for: anXPathSourceString
	^ self new xPathSource: anXPathSourceString
! !

!XPath class methodsFor: 'evaluating' stamp: 'monty 2/9/2015 20:21'!
for: anXPathSourceString in: aNode
	^ (self for: anXPathSourceString) in: aNode
! !

!XPath class methodsFor: 'evaluating' stamp: 'monty 2/9/2015 20:21'!
for: anXPathSourceString in: aNode context: aContext
	^ (self for: anXPathSourceString)
		in: aNode
		context: aContext! !

!XPath class methodsFor: 'class initialization' stamp: 'monty 1/17/2015 04:51'!
initialize
	"self initialize"

	self clearCompiledXPathCache.
	self allSubclassesDo: [:each | self clearCompiledXPathCache]! !

!XPath class methodsFor: 'accessing' stamp: 'monty 1/15/2015 04:49'!
maxCachedCompiledXPaths
	^ self compiledXPathCache maxSize! !

!XPath class methodsFor: 'accessing' stamp: 'monty 1/15/2015 04:50'!
maxCachedCompiledXPaths: anInteger
	self compiledXPathCache maxSize: anInteger! !

!XPath methodsFor: 'converting' stamp: 'monty 1/17/2015 04:38'!
asXPath
	^ self! !

!XPath methodsFor: 'accessing' stamp: 'monty 2/9/2015 20:21'!
compiledXPath
	^ self class
		compiledXPathCacheAt: self xPathSource
		ifAbsentPut: [self compiler compile: self xPathSource]! !

!XPath methodsFor: 'accessing' stamp: 'monty 1/11/2015 10:14'!
compiler
	^ compiler ifNil: [compiler := self compilerClass new]! !

!XPath methodsFor: 'accessing' stamp: 'monty 1/11/2015 10:14'!
compiler: aCompiler
	compiler := aCompiler! !

!XPath methodsFor: 'accessing' stamp: 'monty 12/22/2014 03:12'!
compilerClass
	^ XPathCompiler! !

!XPath methodsFor: 'accessing' stamp: 'monty 1/19/2015 08:26'!
contextClass
	^ XPathContext! !

!XPath methodsFor: 'evaluating' stamp: 'monty 2/13/2015 20:44'!
evaluate
	^ self in: nil! !

!XPath methodsFor: 'evaluating' stamp: 'monty 2/9/2015 20:09'!
in: aNode
	^ self
		in: aNode
		context: self contextClass new! !

!XPath methodsFor: 'evaluating' stamp: 'monty 2/9/2015 20:18'!
in: aNode context: aContext
	^ self compiledXPath
		value: aNode
		value: aContext! !

!XPath methodsFor: 'accessing' stamp: 'monty 2/9/2015 20:21'!
xPathSource
	^ xPathSource! !

!XPath methodsFor: 'accessing' stamp: 'monty 2/9/2015 20:21'!
xPathSource: anXPathSourceString
	xPathSource := anXPathSourceString! !

Object subclass: #XPathAxis
	instanceVariableNames: 'axisSpecifier isImplicit isStartOfRelativeLocationPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathAxis commentStamp: 'monty 1/10/2015 01:54' prior: 0!
A class for storing the axis of a step while it is being parsed.!

!XPathAxis methodsFor: 'accessing' stamp: 'monty 1/13/2015 11:27'!
axisSpecifier
	^ axisSpecifier! !

!XPathAxis methodsFor: 'accessing' stamp: 'monty 1/13/2015 12:11'!
axisSpecifier: anAxisSpecifier
	axisSpecifier := anAxisSpecifier.
	isImplicit := false.! !

!XPathAxis methodsFor: 'handling' stamp: 'monty 1/14/2015 02:41'!
handleWith: aHandler
	self isStartOfRelativeLocationPath
		ifTrue: [aHandler handleStartRelativeLocationPath].
	aHandler handleAxisSpecifier: self axisSpecifier.
	self reset.! !

!XPathAxis methodsFor: 'initialization' stamp: 'monty 2/13/2015 20:47'!
initialize
	super initialize.
	self reset.! !

!XPathAxis methodsFor: 'testing' stamp: 'monty 1/13/2015 11:27'!
isImplicit
	^ isImplicit! !

!XPathAxis methodsFor: 'testing' stamp: 'monty 1/14/2015 02:34'!
isStartOfRelativeLocationPath
	^ isStartOfRelativeLocationPath! !

!XPathAxis methodsFor: 'accessing' stamp: 'monty 1/14/2015 02:35'!
isStartOfRelativeLocationPath: aBoolean
	isStartOfRelativeLocationPath := aBoolean! !

!XPathAxis methodsFor: 'accessing' stamp: 'monty 1/14/2015 02:34'!
reset
	axisSpecifier := 'child'.
	isImplicit := true.
	isStartOfRelativeLocationPath := false.! !

Object subclass: #XPathCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core'!

!XPathCompiler commentStamp: 'monty 1/18/2015 06:22' prior: 0!
This class compiles XPath expressions by first translating them into Smalltalk using an XPathExpressionParser and handler and then compiling the result with the system compiler.!

!XPathCompiler methodsFor: 'compiling' stamp: 'monty 1/12/2015 05:01'!
compile: aStringOrStream
	^ self compileWithParser:
		(self parserClass
			on: aStringOrStream
			for: self parserHandlerClass new)! !

!XPathCompiler methodsFor: 'private' stamp: 'monty 2/10/2015 01:56'!
compileSource: aString
	"overridden in Gemstone version"
	^ Compiler evaluate: aString! !

!XPathCompiler methodsFor: 'compiling' stamp: 'monty 1/11/2015 10:07'!
compileWithParser: aParser
	^ self compileSource: aParser parse! !

!XPathCompiler methodsFor: 'accessing' stamp: 'monty 1/8/2015 05:56'!
parserClass
	^ XPathExpressionParser! !

!XPathCompiler methodsFor: 'accessing' stamp: 'monty 1/11/2015 10:12'!
parserHandlerClass
	^ XPathExpressionParserHandler! !

Object subclass: #XPathContext
	instanceVariableNames: 'variables functions namespaceScope functionStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core'!

XPathContext class
	instanceVariableNames: 'defaultFunctions'!

!XPathContext commentStamp: 'monty 1/19/2015 11:01' prior: 0!
An XPath context is used to evaluate XPath expressions. Each context has a function library and optionally also variable bindings and namespace mappings.

If no namespace mappings are present, then name tests like 'prefix:name', '*:name', and 'prefix:*' will ignore namespaces and match against node prefixes and local names while unqualified name tests will match against both unqualified names and the local parts of qualified names.!

XPathContext class
	instanceVariableNames: 'defaultFunctions'!

!XPathContext class methodsFor: 'accessing' stamp: 'monty 1/18/2015 05:53'!
defaultFunctions
	^ defaultFunctions ifNil: [defaultFunctions := XPathFunctionSet default]! !

!XPathContext class methodsFor: 'accessing' stamp: 'monty 1/18/2015 05:53'!
defaultFunctions: aFunctionSet
	defaultFunctions := aFunctionSet! !

!XPathContext class methodsFor: 'instance creation' stamp: 'monty 2/13/2015 20:49'!
functions: aFunctionSet
	^ self new functions: aFunctionSet! !

!XPathContext class methodsFor: 'instance creation' stamp: 'monty 2/13/2015 20:48'!
namespaces: anAssociationCollection
	^ self new declareNamespaces: anAssociationCollection! !

!XPathContext class methodsFor: 'instance creation' stamp: 'monty 2/13/2015 20:48'!
variables: anAssociationCollection
	^ self new variables: anAssociationCollection! !

!XPathContext class methodsFor: 'instance creation' stamp: 'monty 2/13/2015 20:50'!
variables: aVariableAssociationCollection namespaces: aNamepsaceAssociationCollection
	^ self new
		variables: aVariableAssociationCollection;
		declareNamespaces: aNamepsaceAssociationCollection! !

!XPathContext class methodsFor: 'instance creation' stamp: 'monty 2/13/2015 20:50'!
variables: aVariableAssociationCollection namespaces: aNamepsaceAssociationCollection functions: aFunctionSet
	^ self new
		variables: aVariableAssociationCollection;
		declareNamespaces: aNamepsaceAssociationCollection;
		functions: aFunctionSet! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 1/17/2015 12:07'!
addFunction: aFunction
	functions := self functions + aFunction! !

!XPathContext methodsFor: 'namespaces' stamp: 'monty 1/19/2015 08:24'!
declareNamespaces: anAssociationCollection
	self namespaceScope mapPrefixesAndURIs: anAssociationCollection! !

!XPathContext methodsFor: 'namespaces' stamp: 'monty 1/19/2015 08:25'!
declarePrefix: aPrefix uri: aUri
	self namespaceScope
		mapPrefix: aPrefix
		to: aUri! !

!XPathContext methodsFor: 'private' stamp: 'monty 1/18/2015 14:01'!
errorUndeclaredFunction: aFunctionName
	XPathUndeclaredFunctionException
		formatSignal: 'Undeclared function {1}()'
		with: aFunctionName! !

!XPathContext methodsFor: 'private' stamp: 'monty 1/18/2015 14:02'!
errorUndeclaredVariable: aVariableName
	XPathUndeclaredVariableException
		formatSignal: 'Undeclared variable reference ${1}'
		with: aVariableName! !

!XPathContext methodsFor: 'private' stamp: 'monty 2/10/2015 19:20'!
function: aFunctionName contextNode: aContextNode
	^ (self functions
		functionNamed: aFunctionName
		ifAbsent: [self errorUndeclaredFunction: aFunctionName])
		context: self
		contextNode: aContextNode! !

!XPathContext methodsFor: 'private' stamp: 'monty 1/18/2015 08:54'!
functions
	^ functions ifNil: [functions := self class defaultFunctions]! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 1/17/2015 12:07'!
functions: aFunctionSet
	functions := aFunctionSet! !

!XPathContext methodsFor: 'testing' stamp: 'monty 2/13/2015 01:02'!
hasNamespaces
	^ namespaceScope notNil
		and: [namespaceScope hasNamespaces]! !

!XPathContext methodsFor: 'testing' stamp: 'monty 2/10/2015 22:05'!
includesFunction: aFunction
	^ self functions includes: aFunction! !

!XPathContext methodsFor: 'testing' stamp: 'monty 1/17/2015 04:48'!
includesVariable: aVariableName
	^ self variables includesKey: aVariableName! !

!XPathContext methodsFor: 'initialization' stamp: 'monty 1/1/2015 00:54'!
initialize
	super initialize.
	functionStack := OrderedCollection new.! !

!XPathContext methodsFor: 'testing' stamp: 'monty 2/13/2015 20:52'!
isDeclaredPrefix: aPrefix
	^ self namespaceScope includesPrefix: aPrefix! !

!XPathContext methodsFor: 'testing' stamp: 'monty 2/13/2015 20:52'!
isDeclaredPrefix: aPrefix uri: aUri
	^ self namespaceScope includesPrefix: aPrefix mappedTo: aUri! !

!XPathContext methodsFor: 'private' stamp: 'monty 12/30/2014 03:46'!
namespaceScope
	^ namespaceScope ifNil: [namespaceScope := XMLNamespaceScope new]! !

!XPathContext methodsFor: 'private' stamp: 'monty 1/14/2015 04:57'!
pop
	^ functionStack removeLast! !

!XPathContext methodsFor: 'namespaces' stamp: 'monty 12/30/2014 16:53'!
prefixOfNamespaceURI: aNamespaceUri
	^ self namespaceScope prefixMappings
		keyAtValue: aNamespaceUri
		ifAbsent: ['']! !

!XPathContext methodsFor: 'private' stamp: 'monty 1/14/2015 04:57'!
push: anObject
	^ functionStack addLast: anObject! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 1/17/2015 12:07'!
removeFunction: aFunction
	functions := self functions - aFunction! !

!XPathContext methodsFor: 'namespaces' stamp: 'monty 12/30/2014 03:49'!
resolvePrefix: aPrefix
	^ self namespaceScope resolvePrefix: aPrefix! !

!XPathContext methodsFor: 'private' stamp: 'monty 2/13/2015 01:02'!
testForAnyLocalNameAfterPrefix: aPrefix
	self hasNamespaces
		ifTrue: [| namespaceUri |
			namespaceUri := self resolvePrefix: aPrefix.
			^ [:node |
					"default namespaces are supposed to be ignored for this
					test, so a prefix is required"
					node isPrincipalNode
						and: [node namespaceURI = namespaceUri
							and: [node hasPrefix]]]]
		ifFalse: [
			^ [:node |
				node isPrincipalNode
					and: [node prefix = aPrefix]]]! !

!XPathContext methodsFor: 'private' stamp: 'monty 2/13/2015 01:02'!
testForLocalName: aLocalName
	self hasNamespaces
		ifTrue: [
			"in this mode an unqualified name matches only another
			unqualfied name with the same local part"
			^ [:node |
					node isPrincipalNode
						and: [node name = aLocalName]]]
		ifFalse: [
			^ [:node |
				node isPrincipalNode
					and: [node localName = aLocalName]]]! !

!XPathContext methodsFor: 'private' stamp: 'monty 2/13/2015 01:02'!
testForPrefix: aPrefix localName: aLocalName
	self hasNamespaces
		ifTrue: [| namespaceUri |
			namespaceUri := self resolvePrefix: aPrefix.
			^ [:node |
					"default namespaces are supposed to be ignored for this
					test, so a prefix is required"
					node isPrincipalNode
						and: [node localName = aLocalName
							and: [node namespaceURI = namespaceUri
								and: [node hasPrefix]]]]]
		ifFalse: [| name |
			name := aLocalName qualifyWithPrefix: aPrefix.
			^ [:node |
				node isPrincipalNode
					and: [node name = name]]]! !

!XPathContext methodsFor: 'namespaces' stamp: 'monty 12/30/2014 03:48'!
undeclarePrefix: aPrefix
	self namespaceScope unmapPrefix: aPrefix! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 1/18/2015 14:00'!
variableAt: aVariableName
	^ self variables
		at: aVariableName
		ifAbsent: [self errorUndeclaredVariable: aVariableName]! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 1/17/2015 04:49'!
variableAt: aVariableName ifAbsent: aBlock
	^ self variables
		at: aVariableName
		ifAbsent: aBlock! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 1/17/2015 04:49'!
variableAt: aVariableName ifAbsentPut: aBlock
	^ self variables
		at: aVariableName
		ifAbsentPut: aBlock! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 1/17/2015 04:48'!
variableAt: aVariableName put: aValue
	^ self variables
		at: aVariableName
		put: aValue! !

!XPathContext methodsFor: 'private' stamp: 'monty 1/17/2015 04:49'!
variables
	^ variables ifNil: [variables := Dictionary new]! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 2/13/2015 00:55'!
variables: anAssociationCollection
	variables :=
		anAssociationCollection isDictionary
			ifTrue: [anAssociationCollection]
			ifFalse: [Dictionary withAll: anAssociationCollection]! !

Object subclass: #XPathFunction
	instanceVariableNames: 'context contextNode totalPushedArguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

XPathFunction class
	instanceVariableNames: 'returnType functionName minArguments maxArguments argumentTypes'!

!XPathFunction commentStamp: 'monty 2/9/2015 22:08' prior: 0!
An abstract class for XPath functions. Subclasses need to override the class-side functionPrototype method to return a string containing an XPath function prototype and then implement the instance-side function method.

The arguments are pushed onto the stack and need to be manually popped off (functions can have optional arguments, or take an unbounded number of arguments)!

XPathFunction class
	instanceVariableNames: 'returnType functionName minArguments maxArguments argumentTypes'!

XPathFunction subclass: #XPathBooleanFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathBooleanFunction commentStamp: 'monty 12/22/2014 17:15' prior: 0!
XPath boolean conversion function.!

!XPathBooleanFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 17:30'!
functionPrototype
	^ 'boolean boolean(object)'! !

!XPathBooleanFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:49'!
function
	^ self pop! !

XPathFunction subclass: #XPathCeilingFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathCeilingFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath ceiling function.!

!XPathCeilingFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:19'!
functionPrototype
	^ 'number ceiling(number)'! !

!XPathCeilingFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:49'!
function
	^ self pop ceiling! !

XPathFunction subclass: #XPathConcatFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathConcatFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath string concatenation function.!

!XPathConcatFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 17:32'!
functionPrototype
	^ 'string concat(string, string, string*)'! !

!XPathConcatFunction methodsFor: 'invoking' stamp: 'monty 1/19/2015 06:08'!
function
	| concatenation |

	concatenation := self pop.
	[self totalPushedArguments > 0]
		whileTrue: [concatenation := self pop, concatenation].
	^ concatenation.! !

XPathFunction subclass: #XPathContainsFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathContainsFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath contains substring function.!

!XPathContainsFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:37'!
functionPrototype
	^ 'boolean contains(string, string)'! !

!XPathContainsFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:51'!
function
	| substring |

	substring := self pop.
	"use findString:startingAt: for portability"
	^ (self pop
		findString: substring
		startingAt: 1) > 0! !

XPathFunction subclass: #XPathCountFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathCountFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath NodeSet count (size) function.!

!XPathCountFunction class methodsFor: 'accessing' stamp: 'monty 12/25/2014 00:08'!
functionPrototype
	^ 'number count(node-set)'! !

!XPathCountFunction methodsFor: 'invoking' stamp: 'monty 12/25/2014 00:09'!
function
	^ self pop size! !

XPathFunction subclass: #XPathEndsWithFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathEndsWithFunction commentStamp: 'monty 2/12/2015 20:25' prior: 0!
Non-standard, but added for completeness with starts-with().!

!XPathEndsWithFunction class methodsFor: 'accessing' stamp: 'monty 2/12/2015 20:24'!
functionPrototype
	^ 'boolean ends-with(string, string)'! !

!XPathEndsWithFunction methodsFor: 'invoking' stamp: 'monty 2/12/2015 20:25'!
function
	| substring |

	substring := self pop.
	^ self pop endsWith: substring.! !

XPathFunction subclass: #XPathFalseFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathFalseFunction commentStamp: 'monty 12/22/2014 17:15' prior: 0!
XPath false function.!

!XPathFalseFunction class methodsFor: 'accessing' stamp: 'monty 12/21/2014 23:27'!
functionPrototype
	^ 'boolean false()'! !

!XPathFalseFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:51'!
function
	^ false! !

XPathFunction subclass: #XPathFloorFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathFloorFunction commentStamp: 'monty 12/22/2014 21:18' prior: 0!
XPath floor function.!

!XPathFloorFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:17'!
functionPrototype
	^ 'number floor(number)'! !

!XPathFloorFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:55'!
function
	^ self pop floor! !

!XPathFunction class methodsFor: 'composition' stamp: 'monty 12/29/2014 21:32'!
+ aFunctionOrFunctionSet
	^ aFunctionOrFunctionSet asFunctionSetWithFunction: self! !

!XPathFunction class methodsFor: 'composition' stamp: 'monty 12/29/2014 21:33'!
- aFunctionOrFunctionSet
	^ aFunctionOrFunctionSet asFunctionSetSubtractedFromFunction: self! !

!XPathFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 18:00'!
argumentTypes
	^ argumentTypes
		ifNil: [
			self parseFunctionPrototype.
			argumentTypes]! !

!XPathFunction class methodsFor: 'converting' stamp: 'monty 1/15/2015 09:51'!
asFunctionSet
	^ XPathFunctionSet with: self! !

!XPathFunction class methodsFor: 'converting' stamp: 'monty 1/15/2015 09:54'!
asFunctionSetSubtractedFromFunction: aFunction
	^ aFunction asFunctionSet copyWithout: self! !

!XPathFunction class methodsFor: 'converting' stamp: 'monty 12/29/2014 21:34'!
asFunctionSetSubtractedFromFunctions: aFunctionSet
	^ aFunctionSet copyWithout: self! !

!XPathFunction class methodsFor: 'converting' stamp: 'monty 1/17/2015 12:15'!
asFunctionSetWithFunction: aFunction
	^ self asFunctionSet
		add: aFunction;
		yourself! !

!XPathFunction class methodsFor: 'converting' stamp: 'monty 1/17/2015 12:16'!
asFunctionSetWithFunctions: aFunctionSet
	^ self asFunctionSet
		addAll: aFunctionSet;
		yourself! !

!XPathFunction class methodsFor: 'private' stamp: 'monty 12/22/2014 18:03'!
classForTypeName: aTypeName
	aTypeName = 'object'
		ifTrue: [^ Object].
	aTypeName = 'boolean'
		ifTrue: [^ Boolean].
	aTypeName = 'string'
		ifTrue: [^ String].
	aTypeName = 'number'
		ifTrue: [^ Number].
	aTypeName = 'node-set'
		ifTrue: [^ XPathNodeSet].
	^ nil.! !

!XPathFunction class methodsFor: 'instance creation' stamp: 'monty 12/29/2014 06:24'!
context: aContext contextNode: aContextNode
	^ self new
		setContext: aContext
		contextNode: aContextNode! !

!XPathFunction class methodsFor: 'accessing' stamp: 'monty 12/21/2014 23:16'!
functionName
	^ functionName
		ifNil: [
			self parseFunctionPrototype.
			functionName]! !

!XPathFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:36'!
functionPrototype
	"should return a protype string. see subclasses for examples."
	self subclassResponsibility! !

!XPathFunction class methodsFor: 'accessing' stamp: 'monty 12/21/2014 23:23'!
maxArguments
	^ maxArguments
		ifNil: [
			self parseFunctionPrototype.
			maxArguments]! !

!XPathFunction class methodsFor: 'accessing' stamp: 'monty 12/21/2014 23:23'!
minArguments
	^ minArguments
		ifNil: [
			self parseFunctionPrototype.
			minArguments]! !

!XPathFunction class methodsFor: 'private' stamp: 'monty 1/9/2015 07:39'!
parseFunctionPrototype
	(XPathFunctionPrototypeParser
		on: self functionPrototype
		for: (XPathFunctionPrototypeParserHandler function: self))
		parse! !

!XPathFunction class methodsFor: 'accessing' stamp: 'monty 12/23/2014 14:30'!
returnType
	^ returnType
		ifNil: [
			self parseFunctionPrototype.
			returnType]! !

!XPathFunction class methodsFor: 'private' stamp: 'monty 12/23/2014 14:31'!
setReturnType: aReturnType functionName: aName minArguments: aMinimum maxArguments: aMaximum argumentTypes: anArgumentTypeCollection
	returnType := aReturnType.
	functionName := aName.
	minArguments := aMinimum.
	maxArguments := aMaximum.
	argumentTypes := anArgumentTypeCollection asArray.! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 12/23/2014 14:42'!
argumentTypeAt: anInteger
	^ self argumentTypes at: (anInteger min: self argumentTypes size)! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 12/22/2014 18:12'!
argumentTypes
	^ self class argumentTypes! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 12/24/2014 23:45'!
context
	^ context! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 1/14/2015 04:58'!
contextNode
	^ contextNode! !

!XPathFunction methodsFor: 'private' stamp: 'monty 1/18/2015 13:59'!
errorTooFewArguments
	XPathArgumentNumberException
		formatSignal: '{1}() requires at least {2} arguments'
		with: self functionName
		with: self minArguments! !

!XPathFunction methodsFor: 'private' stamp: 'monty 1/18/2015 13:59'!
errorTooManyArguments
	XPathArgumentNumberException
		formatSignal: '{1}() accepts at most {2} arguments'
		with: self functionName
		with: self maxArguments! !

!XPathFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:49'!
function
	self subclassResponsibility! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 12/22/2014 18:12'!
functionName
	^ self class functionName! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 12/27/2014 03:50'!
functionPrototype
	^ self class functionPrototype! !

!XPathFunction methodsFor: 'invoking' stamp: 'monty 12/27/2014 04:08'!
invoke
	totalPushedArguments < self minArguments
		ifTrue: [self errorTooFewArguments].

	^ self returnType xPathNewFrom: self function.! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 12/22/2014 18:12'!
maxArguments
	^ self class maxArguments! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 12/22/2014 18:12'!
minArguments
	^ self class minArguments! !

!XPathFunction methodsFor: 'stack' stamp: 'monty 2/9/2015 22:08'!
pop
	totalPushedArguments := totalPushedArguments - 1.
	^ context pop.! !

!XPathFunction methodsFor: 'printing' stamp: 'monty 1/19/2015 12:57'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPutAll: '(''';
		nextPutAll: self functionPrototype;
		nextPutAll: ''')'.! !

!XPathFunction methodsFor: 'stack' stamp: 'monty 1/14/2015 04:58'!
push: anArgument
	self maxArguments
		ifNotNil: [:maxArguments |
			totalPushedArguments >= maxArguments
				ifTrue: [self errorTooManyArguments]].

	totalPushedArguments := totalPushedArguments + 1.
	context push:
		((self argumentTypeAt: totalPushedArguments)
			xPathNewFrom: anArgument).! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 12/23/2014 14:38'!
returnType
	^ self class returnType! !

!XPathFunction methodsFor: 'initialization' stamp: 'monty 12/29/2014 06:25'!
setContext: aContext contextNode: aContextNode
	context := aContext.
	contextNode := aContextNode.
	totalPushedArguments := 0.! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 12/26/2014 03:32'!
totalPushedArguments
	^ totalPushedArguments! !

XPathFunction subclass: #XPathLangFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathLangFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath xml:lang testing function.!

!XPathLangFunction class methodsFor: 'accessing' stamp: 'monty 12/23/2014 15:18'!
functionPrototype
	^ 'boolean lang(string)'! !

!XPathLangFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:55'!
function
	| language |

	language := self pop.
	^ self contextNode isInLanguage: language.! !

XPathFunction subclass: #XPathLocalNameFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathLocalNameFunction commentStamp: 'monty 12/27/2014 00:36' prior: 0!
XPath local name function.!

!XPathLocalNameFunction class methodsFor: 'accessing' stamp: 'monty 12/27/2014 00:19'!
functionPrototype
	^ 'string local-name(node-set?)'! !

!XPathLocalNameFunction methodsFor: 'invoking' stamp: 'monty 1/18/2015 16:45'!
function
	| node |

	self totalPushedArguments > 0
		ifTrue: [node := self pop firstInDocumentOrder]
		ifFalse: [node := self contextNode].

	(node notNil and: [node hasExpandedName])
		ifTrue: [^ node localName]
		ifFalse: [^ '']! !

XPathFunction subclass: #XPathNameFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathNameFunction commentStamp: 'monty 12/27/2014 00:36' prior: 0!
XPath name function.!

!XPathNameFunction class methodsFor: 'accessing' stamp: 'monty 12/27/2014 00:22'!
functionPrototype
	^ 'string name(node-set?)'! !

!XPathNameFunction methodsFor: 'invoking' stamp: 'monty 1/20/2015 12:16'!
function
	| node |

	self totalPushedArguments > 0
		ifTrue: [node := self pop firstInDocumentOrder]
		ifFalse: [node := self contextNode].

	(node notNil and: [node hasExpandedName])
		ifTrue: [| namespaceUri |
			(self context hasNamespaces
				and: [(namespaceUri := node namespaceURI) notEmpty
					and: [node hasPrefix]])
				ifTrue: [
					^ node localName qualifyWithPrefix:
						(self context prefixOfNamespaceURI: namespaceUri)]
				ifFalse: [^ node name]]
		ifFalse: [^ ''].! !

XPathFunction subclass: #XPathNamespaceURIFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathNamespaceURIFunction commentStamp: 'monty 12/27/2014 00:27' prior: 0!
XPath namespace URI function.!

!XPathNamespaceURIFunction class methodsFor: 'accessing' stamp: 'monty 12/27/2014 00:20'!
functionPrototype
	^ 'string namespace-uri(node-set?)'! !

!XPathNamespaceURIFunction methodsFor: 'invoking' stamp: 'monty 1/20/2015 12:18'!
function
	| node |

	self totalPushedArguments > 0
		ifTrue: [node := self pop firstInDocumentOrder]
		ifFalse: [node := self contextNode].

	(node notNil and: [node hasExpandedName])
		ifTrue: [^ node namespaceURI]
		ifFalse: [^ '']! !

XPathFunction subclass: #XPathNormalizeSpaceFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathNormalizeSpaceFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath whitespace normalizeation function.!

!XPathNormalizeSpaceFunction class methodsFor: 'accessing' stamp: 'monty 12/25/2014 04:35'!
functionPrototype
	^ 'string normalize-space(string?)'! !

!XPathNormalizeSpaceFunction methodsFor: 'invoking' stamp: 'monty 12/26/2014 03:32'!
function
	| string writeStream isInWhitespace |

	self totalPushedArguments > 0
		ifTrue: [string := self pop]
		ifFalse: [string := self contextNode].

	writeStream := (String new: string size) writeStream.
	isInWhitespace := false.
	string do: [:each |
		each isSeparator
			ifTrue: [
				isInWhitespace
					ifFalse: [isInWhitespace := true]]
			ifFalse: [
				isInWhitespace
					ifTrue: [
						writeStream xmlParserAtBeginning
							ifFalse: [writeStream nextPut: $ ].
						isInWhitespace := false].
				writeStream nextPut: each]].
	^ writeStream contents.! !

XPathFunction subclass: #XPathNotFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathNotFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath negation function.!

!XPathNotFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:10'!
functionPrototype
	^ 'boolean not(boolean)'! !

!XPathNotFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:57'!
function
	^ self pop not! !

XPathFunction subclass: #XPathNumberFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathNumberFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath number conversion function.!

!XPathNumberFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:11'!
functionPrototype
	^ 'number number(object?)'! !

!XPathNumberFunction methodsFor: 'invoking' stamp: 'monty 12/26/2014 03:32'!
function
	self totalPushedArguments > 0
		ifTrue: [^ self pop]
		ifFalse: [^ XPathNodeSet with: self contextNode]! !

XPathFunction subclass: #XPathRoundFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathRoundFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath number rounding function.!

!XPathRoundFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:20'!
functionPrototype
	^ 'number round(number)'! !

!XPathRoundFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:58'!
function
	^ self pop rounded! !

XPathFunction subclass: #XPathStartsWithFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathStartsWithFunction commentStamp: 'monty 2/10/2015 02:59' prior: 0!
XPath string prefix testing function.!

!XPathStartsWithFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:25'!
functionPrototype
	^ 'boolean starts-with(string, string)'! !

!XPathStartsWithFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:59'!
function
	| substring |

	substring := self pop.
	^ self pop beginsWith: substring.! !

XPathFunction subclass: #XPathStringFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathStringFunction commentStamp: 'monty 12/22/2014 20:01' prior: 0!
XPath string conversion function.!

!XPathStringFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 17:30'!
functionPrototype
	^ 'string string(object?)'! !

!XPathStringFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:59'!
function
	^ self pop! !

XPathFunction subclass: #XPathStringLengthFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathStringLengthFunction commentStamp: 'monty 12/22/2014 21:24' prior: 0!
XPath string length function.
!

!XPathStringLengthFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:22'!
functionPrototype
	^ 'number string-length(string?)'! !

!XPathStringLengthFunction methodsFor: 'invoking' stamp: 'monty 12/26/2014 03:32'!
function
	self totalPushedArguments > 0
		ifTrue: [^ self pop size]
		ifFalse: [^ self contextNode asXPathString size]! !

XPathFunction subclass: #XPathSubstringAfterFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathSubstringAfterFunction commentStamp: 'monty 12/22/2014 21:52' prior: 0!
XPath substring after function.!

!XPathSubstringAfterFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:48'!
functionPrototype
	^ 'string substring-after(string, string)'! !

!XPathSubstringAfterFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:59'!
function
	| substring string indexOfSubstring |

	substring := self pop.
	string := self pop.
	(indexOfSubstring :=
		string
			findString: substring
			startingAt: 1) > 0
		ifTrue: [
			^ string
				copyFrom: indexOfSubstring + substring size
				to: string size]
		ifFalse: [^ ''].! !

XPathFunction subclass: #XPathSubstringBeforeFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathSubstringBeforeFunction commentStamp: 'monty 12/22/2014 21:52' prior: 0!
XPath substring before function.!

!XPathSubstringBeforeFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:40'!
functionPrototype
	^ 'string substring-before(string, string)'! !

!XPathSubstringBeforeFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:54'!
function
	| substring string indexOfSubstring |

	substring := self pop.
	string := self pop.
	(indexOfSubstring :=
		string
			findString: substring
			startingAt: 1) > 0
		ifTrue: [
			^ string
				copyFrom: 1
				to:indexOfSubstring - 1]
		ifFalse: [^ ''].! !

XPathFunction subclass: #XPathSubstringFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathSubstringFunction commentStamp: 'monty 2/10/2015 06:21' prior: 0!
XPath substring function. First argument is source string, second is one-based position, and third is substring length.!

!XPathSubstringFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:53'!
functionPrototype
	^ 'string substring(string, number, number?)'! !

!XPathSubstringFunction methodsFor: 'invoking' stamp: 'monty 2/10/2015 06:36'!
function
	| string start length |

	self totalPushedArguments > 2
		ifTrue: [
			length := self pop rounded.
			start := self pop rounded.
			string := self pop]
		ifFalse: [
			start := self pop rounded.
			string := self pop.
			length := string size - start + 1].

	(length > 0 and: [start <= string size])
		ifTrue: [
			^ string
				copyFrom: (start max: 1)
				to: ((start max: 1) + length - 1 min: string size)]
		ifFalse: [^ '']	.! !

XPathFunction subclass: #XPathSumFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathSumFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath sum function.!

!XPathSumFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:06'!
functionPrototype
	^ 'number sum(node-set)'! !

!XPathSumFunction methodsFor: 'invoking' stamp: 'monty 2/10/2015 21:52'!
function
	^ self pop
		inject: 0
		into: [:i :each | i + each asXPathString asXPathNumber]! !

XPathFunction subclass: #XPathTranslateFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathTranslateFunction commentStamp: 'monty 12/27/2014 00:36' prior: 0!
XPath string search and replacement function.!

!XPathTranslateFunction class methodsFor: 'accessing' stamp: 'monty 12/22/2014 21:57'!
functionPrototype
	^ 'string translate(string, string, string)'! !

!XPathTranslateFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:53'!
function
	| replacementTable translatedString replacementString searchString sourceString |

	replacementTable := IdentityDictionary new.
	replacementString := self pop.
	searchString := self pop.
	1 to: searchString size do: [:i |
		replacementTable
			at: (searchString at: i)
			ifAbsentPut: (replacementString at: i ifAbsent: [nil])].

	sourceString := self pop.
	translatedString := (String new: sourceString size) writeStream.
	sourceString do: [:each |	
		(replacementTable at: each ifAbsent: [each])
			ifNotNil: [:nextChar |
				translatedString nextPut: nextChar]].
	^ translatedString contents.! !

XPathFunction subclass: #XPathTrueFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathTrueFunction commentStamp: 'monty 12/22/2014 17:15' prior: 0!
XPath true function.!

!XPathTrueFunction class methodsFor: 'accessing' stamp: 'monty 12/21/2014 23:24'!
functionPrototype
	^ 'boolean true()'! !

!XPathTrueFunction methodsFor: 'invoking' stamp: 'monty 12/24/2014 23:53'!
function
	^ true! !

Object subclass: #XPathParser
	instanceVariableNames: 'handler inputStream writeStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathParser commentStamp: 'monty 1/8/2015 09:14' prior: 0!
This is a base class for XPath parsers.!

XPathParser subclass: #XPathExpressionParser
	instanceVariableNames: 'currentAxis nodeTestParser'
	classVariableNames: 'AbbreviatedAxisSpecifierCharacters'
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathExpressionParser commentStamp: 'monty 2/10/2015 02:58' prior: 0!
This class parses XPath expressions. It understands all of XPath 1.0 syntax and supports some extensions like abbreviated syntax for other axis specifiers.!

!XPathExpressionParser class methodsFor: 'class initialization' stamp: 'monty 1/10/2015 09:03'!
initialize
	"self initialzie"

	self initializeAbbreviatedAxisSpecifierCharacters! !

!XPathExpressionParser class methodsFor: 'class initialization' stamp: 'monty 1/22/2015 15:52'!
initializeAbbreviatedAxisSpecifierCharacters
	(AbbreviatedAxisSpecifierCharacters := BitmapCharacterSet new)
		addAll: '%@~<>'! !

!XPathExpressionParser methodsFor: 'testing' stamp: 'monty 1/14/2015 04:09'!
atDigit
	^ inputStream peek notNil
		and: [inputStream peek isDigit]! !

!XPathExpressionParser methodsFor: 'private' stamp: 'monty 1/21/2015 18:29'!
errorExpectedNodeTest
	self errorExpected: 'node test after axis'! !

!XPathExpressionParser methodsFor: 'private' stamp: 'monty 1/14/2015 04:35'!
errorExpectedStep
	self errorExpected: 'location path step'! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/23/2015 09:51'!
nextAdditionalSteps
	currentAxis reset.
	(self peekForAbbreviatedDescendantStep
		or: [self peekForStep])
		ifFalse: [self errorExpectedStep].
	[self peekForLocationPathSeparator]
		whileTrue: [
			(self peekForAbbreviatedDescendantStep
				or: [self peekForStep])
				ifFalse: [self errorExpectedStep]].! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/13/2015 10:48'!
nextAdditiveExpression
	handler handleStartAdditiveExpression.
	self nextMultiplicativeExpression.
	[self peekForAdditiveOperator]
		whileTrue: [self nextMultiplicativeExpression].
	handler handleEndAdditiveExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 2/11/2015 00:11'!
nextAndExpression
	| totalShortCircuited |

	handler handleStartAndExpression.
	self nextEqualityExpression.
	totalShortCircuited := 0.
	[self peekForAndOperator]
		whileTrue: [
			handler handleStartShortCircuitAnd.
			totalShortCircuited := totalShortCircuited + 1.
			self nextEqualityExpression].
	handler
		handleEndShortCircuited: totalShortCircuited;
		handleEndAndExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/18/2015 15:21'!
nextDigitsOnWriteStream
	"first digit"
	writeStream nextPut: inputStream next.
	[self atDigit]
		whileTrue: [writeStream nextPut: inputStream next].! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/10/2015 11:10'!
nextEqualityExpression
	handler handleStartEqualityExpression.
	self nextRelationalExpression.
	[self peekForEqualityOperator]
		whileTrue: [self nextRelationalExpression].
	handler handleEndEqualityExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/14/2015 04:08'!
nextFilterExpression
	self
		nextPrimaryExpression;
		peekForPredicates! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/11/2015 12:07'!
nextFunctionArgument
	handler handleStartFunctionArgument.
	self nextOrExpression.
	handler handleEndFunctionArgument.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 2/10/2015 07:40'!
nextFunctionCall
	| name |

	name := self nextName.
	name = 'position'
		ifTrue: [
			handler handlePositionFunctionCall.
			^ self nextEmptyArgumentList].
	name = 'last'
		ifTrue: [
			handler handleLastFunctionCall.
			^ self nextEmptyArgumentList].

	handler handleStartFunctionCall: name.
	self nextStartArgumentList.
	inputStream skipSeparators.
	inputStream peek == $)
		ifFalse: [
			self nextFunctionArgument.
			[self peekForArgumentSeparator]
				whileTrue: [self nextFunctionArgument]].
	self nextEndArgumentList.
	handler handleEndFunctionCall.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 2/10/2015 07:43'!
nextMultiplicativeExpression
	handler handleStartMultiplicativeExpression.
	self nextUnaryExpression.
	[self peekForMultiplicativeOperator]
		whileTrue: [self nextUnaryExpression].
	handler handleEndMultiplicativeExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 2/11/2015 00:11'!
nextOrExpression
	| totalShortCircuited |

	handler handleStartOrExpression.
	self nextAndExpression.
	totalShortCircuited := 0.
	[self peekForOrOperator]
		whileTrue: [
			handler handleStartShortCircuitOr.
			totalShortCircuited := totalShortCircuited + 1.
			self nextAndExpression].
	handler
		handleEndShortCircuited: totalShortCircuited;
		handleEndOrExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/22/2015 22:30'!
nextPathExpression
	handler handleStartPathExpression.
	self peekForLocationPathExpression
		ifFalse: [
			self nextFilterExpression.
			self peekForLocationPathSeparator
				ifTrue: [self nextAdditionalSteps]].
	handler handleEndPathExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/20/2015 19:39'!
nextPrimaryExpression
	inputStream skipSeparators.
	(self peekForVariableReference
		or: [self peekForParenthesizedExpression
			or: [self peekForStringLiteral
				or: [self peekForNumber]]])
		ifFalse: [self nextFunctionCall].! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/13/2015 11:46'!
nextRelationalExpression
	handler handleStartRelationalExpression.
	self nextAdditiveExpression.
	[self peekForRelationalOperator]
		whileTrue: [self nextAdditiveExpression].
	handler handleEndRelationalExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 2/10/2015 22:10'!
nextUnaryExpression
	| totalNegations |

	handler handleStartUnaryExpression.
	totalNegations := 0.
	[self peekForNegationOperator]
		whileTrue: [totalNegations := totalNegations + 1].
	totalNegations odd
		ifTrue: [handler handleNegation].
	self nextUnionExpression.
	handler handleEndUnaryExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/13/2015 11:07'!
nextUnionExpression
	handler handleStartUnionExpression.
	self nextPathExpression.
	[self peekForUnion]
		whileTrue: [self nextPathExpression].
	handler handleEndUnionExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 2/10/2015 02:24'!
parseInput
	currentAxis := XPathAxis new.
	nodeTestParser :=
		XPathNodeTestParser
			on: inputStream
			for:
				(XPathExpressionNodeTestParserHandler
					currentAxis: currentAxis
					expressionParserHandler: handler).
	self nextOrExpression.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 22:11'!
peekFailedAt: aPosition
	inputStream position: aPosition.
	^ false.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/15/2015 04:00'!
peekForAbbreviatedAxis
	| nextChar |

	((nextChar := inputStream peek) notNil
		and: [AbbreviatedAxisSpecifierCharacters includes: nextChar])
		ifFalse: [^ false].
	writeStream
		reset;
		nextPut: inputStream next.
	[(nextChar := inputStream peek) notNil
		and: [AbbreviatedAxisSpecifierCharacters includes: nextChar]]
		whileTrue: [writeStream nextPut: inputStream next].
	currentAxis axisSpecifier: writeStream contents.
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/12/2015 00:43'!
peekForAbbreviatedDescendantStep
	self peekForLocationPathSeparator
		ifFalse: [^ false].

	"// followed by a node test is the same as
	descendant:: followed by the node test"
	currentAxis axisSpecifier: 'descendant'.
	nodeTestParser parse
		ifTrue: [
			self peekForPredicates.
			^ true]
		ifFalse: [
			"// followed by an abbreviated step or step with an
			explicit axis is the same as descendant-or-self::node()/
			followed by the step"
			currentAxis
				axisSpecifier: 'descendant-or-self';
				handleWith: handler.
			handler handleTestForNodeType.
			^ false].! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/2/2015 18:33'!
peekForAbbreviatedStep
	(inputStream peekFor: $.)
		ifFalse: [^ false].
	self atDigit
		ifTrue: [
			inputStream skipBack.
			^ false].
	(inputStream peekFor: $.)
		ifTrue: [currentAxis axisSpecifier: 'parent']
		ifFalse: [
			currentAxis isStartOfRelativeLocationPath
				ifFalse: [
					"can be omitted"
					currentAxis reset.
					^ true].
			currentAxis axisSpecifier: 'self'].
	currentAxis handleWith: handler.
	handler handleTestForNodeType.

	"abbreviated steps cannot have filters"
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 07:39'!
peekForAbsoluteLocationPath
	self peekForLocationPathSeparator
		ifTrue: [
			handler handleStartAbsoluteLocationPath.
			self nextAdditionalSteps.
			^ true]
		ifFalse: [^ false]! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/12/2015 05:10'!
peekForAdditiveOperator
	inputStream skipSeparators.
	(inputStream peekFor: $+)
		ifTrue: [
			handler handleAddition.
			^ true].
	(inputStream peekFor: $-)
		ifTrue: [
			handler handleSubtraction.
			^ true].
	^ false.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 02:35'!
peekForAndOperator
	inputStream skipSeparators.
	^ inputStream peekForAll: 'and'.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 07:40'!
peekForArgumentSeparator
	inputStream skipSeparators.
	^ inputStream peekFor: $,! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/20/2015 11:21'!
peekForAttributePredicate
	| startPosition name isEquals literal |

	inputStream peek == $@
		ifFalse: [^ false].
	
	startPosition := inputStream position.
	inputStream
		next;
		skipSeparators.
	(name := self nextNameOptional: true)
		ifNil: [^ self peekFailedAt: startPosition].

	inputStream skipSeparators.
	(inputStream peekFor: $=)
		ifTrue: [isEquals := true]
		ifFalse: [
			(inputStream peekForAll: '!!=')
				ifTrue: [isEquals := false]
				ifFalse: [^ self peekFailedAt: startPosition]].

	inputStream skipSeparators.
	(literal := self nextStringLiteralOptional: true)
		ifNil: [^ self peekFailedAt: startPosition].

	self peekForEndPredicate
		ifFalse: [^ self peekFailedAt: startPosition].
	isEquals
		ifTrue: [
			handler
				handlePredicateAttribute: name
				equalsStringLiteral: literal]
		ifFalse: [
			handler
				handlePredicateAttribute: name
				notEqualsStringLiteral: literal].
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/14/2015 03:57'!
peekForAxis
	| startPosition ncName |

	self peekForAbbreviatedAxis
		ifTrue: [^ true].
	startPosition := inputStream position.
	(ncName := self nextNCNameOptional: true)
		ifNil: [^ false].
	inputStream skipSeparators.
	((inputStream peekFor: $:)
		and: [inputStream peekFor: $:])
		ifFalse: [
			inputStream pushBackToken:
				(XPathPushedBackNCNameToken
					token: ncName
					position: startPosition).
			^ false].
	currentAxis axisSpecifier: ncName.
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/20/2015 11:12'!
peekForEndPredicate
	inputStream skipSeparators.
	^ inputStream peekFor: $].! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/13/2015 11:45'!
peekForEqualityOperator
	inputStream skipSeparators.
	(inputStream peekForAll: '!!=')
		ifTrue: [
			handler handleNotEquals.
			^ true].
	(inputStream peekFor: $=)
		ifTrue: [
			handler handleEquals.
			^ true].
	^ false.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 02:33'!
peekForIntegerPredicate
	| startPosition |

	self atDigit
		ifFalse: [^ false].
	
	startPosition := inputStream position.
	writeStream reset.
	self nextDigitsOnWriteStream.
	self peekForEndPredicate
		ifTrue: [
			handler handleIntegerPredicate: writeStream contents.
			^ true]
		ifFalse: [^ self peekFailedAt: startPosition].! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/22/2015 22:21'!
peekForLocationPathExpression
	^ self peekForAbsoluteLocationPath
		or: [self peekForRelativeLocationPath]! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/14/2015 02:43'!
peekForLocationPathSeparator
	inputStream skipSeparators.
	^ inputStream peekFor: $/.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 07:43'!
peekForMultiplicativeOperator
	inputStream skipSeparators.
	inputStream atEnd
		ifTrue: [^ false].
	(inputStream peekFor: $*)
		ifTrue: [
			handler handleMultiplication.
			^ true].
	(inputStream peekForAll: 'div')
		ifTrue: [
			handler handleDivision.
			^ true].
	(inputStream peekForAll: 'mod')
		ifTrue: [
			handler handleModulus.
			^ true].
	^ false.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 07:45'!
peekForNegationOperator
	inputStream skipSeparators.
	^ inputStream peekFor: $-.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/20/2015 11:02'!
peekForNumber
	| startPosition |

	startPosition := inputStream position.
	writeStream reset.
	self atDigit
		ifTrue: [
			self nextDigitsOnWriteStream.
			(inputStream peekFor: $.)
				ifTrue: [
					"float literals cannot have trailing '.'"
					self atDigit
						ifTrue: [
							writeStream nextPut: $..
							self nextDigitsOnWriteStream]].
			handler handleNumberLiteral: writeStream contents.
			^ true].
	(inputStream peekFor: $.)
		ifTrue: [
			self atDigit
				ifTrue: [
					"float literals can't have leading '.'"
					writeStream nextPutAll: '0.'.
					self nextDigitsOnWriteStream.
					handler handleNumberLiteral: writeStream contents.
					^ true]].
	^ self peekFailedAt: startPosition.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 02:35'!
peekForOrOperator
	inputStream skipSeparators.
	^ inputStream peekForAll: 'or'.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 07:41'!
peekForParenthesizedExpression
	(inputStream peekFor: $()
		ifFalse: [^ false].

	self nextOrExpression.
	inputStream skipSeparators.
	self expectNext: $).
	^ true.
! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 02:34'!
peekForPredicate
	inputStream skipSeparators.
	(inputStream peekFor: $[)
			ifFalse: [^ false].

	inputStream skipSeparators.
	(self peekForIntegerPredicate
		or: [self peekForAttributePredicate])
		ifTrue: [^ true].

	handler handleStartPredicate.
	self nextOrExpression.
	inputStream skipSeparators.
	self expectNext: $].
	handler handleEndPredicate.
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/1/2015 16:54'!
peekForPredicates
	[self peekForPredicate] whileTrue! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/13/2015 11:48'!
peekForRelationalOperator
	inputStream skipSeparators.
	(inputStream peekFor: $<)
		ifTrue: [
			(inputStream peekFor: $=)
				ifTrue: [handler handleLessThanOrEqualTo]
				ifFalse: [handler handleLessThan].
			^ true].
	(inputStream peekFor: $>)
		ifTrue: [
			(inputStream peekFor: $=)
				ifTrue: [handler handleGreaterThanOrEqualTo]
				ifFalse: [handler handleGreaterThan].
			^ true].
	^ false.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/22/2015 22:30'!
peekForRelativeLocationPath
	currentAxis
		reset;
		isStartOfRelativeLocationPath: true.
	self peekForStep
		ifFalse: [^ false].
	self peekForLocationPathSeparator
		ifTrue: [self nextAdditionalSteps].
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/21/2015 18:30'!
peekForStep
	inputStream skipSeparators.
	inputStream atEnd
		ifTrue: [^ false].
	self peekForAbbreviatedStep
		ifTrue: [^ true].
	self peekForAxis.
	nodeTestParser parse
		ifFalse: [
			currentAxis isImplicit
				ifFalse: [self errorExpectedNodeTest].
			currentAxis reset.
			^ false].
	self peekForPredicates.
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/21/2015 07:12'!
peekForStringLiteral
	(self nextStringLiteralOptional: true)
		ifNil: [^ false]
		ifNotNil: [:string |
			handler handleStringLiteral: string.
			^ true]! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 07:36'!
peekForUnion
	inputStream skipSeparators.
	(inputStream peekFor: $|)
		ifTrue: [
			handler handleUnion.
			^ true]
		ifFalse: [^ false]! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/10/2015 07:36'!
peekForVariableReference
	(inputStream peekFor: $$)
		ifTrue: [
			handler handleVariableReference: self nextName.
			^ true]
		ifFalse: [^ false]! !

XPathParser subclass: #XPathFunctionPrototypeParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathFunctionPrototypeParser commentStamp: 'monty 2/10/2015 02:49' prior: 0!
This class parses XPath function prototypes.!

!XPathFunctionPrototypeParser methodsFor: 'private' stamp: 'monty 1/9/2015 07:26'!
errorArgumentAfterUnboundedArgument
	XPathSyntaxException signal: 'Argument after unbounded "*" argument'! !

!XPathFunctionPrototypeParser methodsFor: 'private' stamp: 'monty 1/9/2015 07:26'!
errorNonOptionalArgumentAfterOptional
	XPathSyntaxException signal: 'Non-optional argument afer optional "?" argument'! !

!XPathFunctionPrototypeParser methodsFor: 'private' stamp: 'monty 1/9/2015 07:23'!
errorUnboundedArgumentAfterOptional
	XPathSyntaxException signal: 'Unbounded "*" argument after optional "?" argument'! !

!XPathFunctionPrototypeParser methodsFor: 'parsing' stamp: 'monty 1/9/2015 07:36'!
nextArgument
	handler hasUnboundedArgument
		ifTrue: [self errorArgumentAfterUnboundedArgument].

	self nextArgumentTypeAndModifier.
	
	inputStream skipSeparators.
	inputStream peek == $)
		ifFalse: [self expectNext: $,].! !

!XPathFunctionPrototypeParser methodsFor: 'parsing' stamp: 'monty 1/9/2015 07:38'!
nextArgumentList
	self nextStartArgumentList.
	[inputStream skipSeparators.
	inputStream peek == $)]
		whileFalse: [self nextArgument].
	self nextEndArgumentList.! !

!XPathFunctionPrototypeParser methodsFor: 'parsing' stamp: 'monty 1/9/2015 07:37'!
nextArgumentTypeAndModifier
	| argument |
	
	argument := self nextName.
	(inputStream peekFor: $*)
		ifTrue: [
			handler hasOptionalArgument
				ifTrue: [self errorUnboundedArgumentAfterOptional].
			handler handleUnboundedArgument: argument]
		ifFalse: [
			(inputStream peekFor: $?)
				ifTrue: [handler handleOptionalArgument: argument]
				ifFalse: [
					handler hasOptionalArgument
						ifTrue: [self errorNonOptionalArgumentAfterOptional].
					handler handleArgument: argument]].! !

!XPathFunctionPrototypeParser methodsFor: 'parsing' stamp: 'monty 1/9/2015 07:38'!
nextFunctionName
	inputStream skipSeparators.
	handler handleFunctionName: self nextName.! !

!XPathFunctionPrototypeParser methodsFor: 'parsing' stamp: 'monty 1/9/2015 07:37'!
nextReturnType
	inputStream skipSeparators.
	handler handleReturnType: self nextName.! !

!XPathFunctionPrototypeParser methodsFor: 'parsing' stamp: 'monty 2/10/2015 02:26'!
parseInput
	self
		nextReturnType;
		nextFunctionName;
		nextArgumentList! !

XPathParser subclass: #XPathNodeTestParser
	instanceVariableNames: 'nameStartPosition'
	classVariableNames: 'NodeTypeParserSelectors'
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNodeTestParser commentStamp: 'monty 2/10/2015 02:56' prior: 0!
This class parses node tests that are either node name tests like 'name' or '*' or node type tests like 'node()' or 'comment()'.!

!XPathNodeTestParser class methodsFor: 'class initialization' stamp: 'monty 1/23/2015 12:29'!
initialize 
	"self initialize"

	self initializeNodeTypeParserSelectors! !

!XPathNodeTestParser class methodsFor: 'class initialization' stamp: 'monty 1/23/2015 12:29'!
initializeNodeTypeParserSelectors
	(NodeTypeParserSelectors := Dictionary new)
		at: 'comment' put: #nextCommentNodeTypeTest;
		at: 'text' put: #nextTextNodeTypeTest;
		at: 'processing-instruction' put: #nextPINodeTypeTest;
		at: 'node' put: #nextNodeNodeTypeTest! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 1/14/2015 02:52'!
nextCommentNodeTypeTest
	self nextEmptyArgumentList.
	handler handleTestForCommentType.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 1/14/2015 02:53'!
nextExpandedNameTest
	handler
		handleTestForNamespaceURI: (self expectUpTo: $})
		localName: self nextNCName! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 1/23/2015 20:01'!
nextLocalNameOrNodeTypeTest: aName
	inputStream skipSeparators.
	inputStream peek == $: "axis specifier"
		ifTrue: [^ self pushBackNCName: aName].
	inputStream peek == $(
		ifTrue: [^ self nextNodeTypeTestOrFunction: aName].

	handler handleTestForLocalName: aName.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 1/14/2015 02:53'!
nextNodeNodeTypeTest
	self nextEmptyArgumentList.
	handler handleTestForNodeType.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 1/23/2015 20:01'!
nextNodeTypeTestOrFunction: aNodeType
	self perform:
		(NodeTypeParserSelectors
			at: aNodeType
			ifAbsent: [^ self pushBackNCName: aNodeType])! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 1/20/2015 10:53'!
nextPINodeTypeTest
	self nextStartArgumentList.
	inputStream skipSeparators.
	handler handleTestForPIType:
		((self nextStringLiteralOptional: true) ifNil: ['']).
	self nextEndArgumentList.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 1/31/2015 20:11'!
nextQualifiedNameTestOrFunction: aPrefix
	| localName |

	(inputStream peekFor: $*)
		ifTrue: [^ handler handleTestForAnyLocalNameAfterPrefix: aPrefix].
	localName := self nextNCName.
	inputStream skipSeparators.
	inputStream peek == $( "function"
		ifTrue: [^ self pushBackName: (localName qualifyWithPrefix: aPrefix)].
	^ handler
		handleTestForPrefix: aPrefix
		localName: localName.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 1/14/2015 02:50'!
nextTextNodeTypeTest
	self nextEmptyArgumentList.
	handler handleTestForTextType.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 1/24/2015 13:09'!
nextWildCardNameTest
	(inputStream peekFor: $:)
		ifTrue: [
			(inputStream peekFor: $*)
				ifTrue: [handler handleTestForAnyName]
				ifFalse: [handler handleTestForAnyPrefixBeforeLocalName: self nextNCName]]
		ifFalse: [handler handleTestForAnyName]! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 1/23/2015 19:44'!
parseInput
	| name |

	inputStream skipSeparators.
	inputStream atEnd
		ifTrue: [
			handler handleEmptyTest.
			^ self].

	(inputStream peekFor: $*)
		ifTrue: [^ self nextWildCardNameTest].

	nameStartPosition := inputStream position.
	(name := self nextNCNameOptional: true)
		ifNil: [
			handler handleEmptyTest.
			^ self].
	(name = 'Q'
		and: [inputStream peekFor: ${])
		ifTrue: [^ self nextExpandedNameTest].
	(inputStream peekFor: $:)
		ifTrue: [
			(inputStream peekFor: $:) "axis specifier"
				ifTrue: [^ self pushBackName: name]
				ifFalse: [^ self nextQualifiedNameTestOrFunction: name]].

	self nextLocalNameOrNodeTypeTest: name.! !

!XPathNodeTestParser methodsFor: 'private' stamp: 'monty 1/23/2015 12:23'!
pushBackNCName: aLocalName
	inputStream pushBackToken:
		(XPathPushedBackNCNameToken
			token: aLocalName
			position: nameStartPosition).
	handler handleEmptyTest.! !

!XPathNodeTestParser methodsFor: 'private' stamp: 'monty 1/23/2015 12:23'!
pushBackName: aLocalName
	inputStream pushBackToken:
		(XPathPushedBackNameToken
			token: aLocalName
			position: nameStartPosition).
	handler handleEmptyTest.! !

!XPathParser class methodsFor: 'instance creation' stamp: 'monty 1/8/2015 06:01'!
on: aStringOrStream for: aHandler
	^ self new
		on: aStringOrStream
		for: aHandler! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 2/10/2015 02:27'!
endParsing
	handler handleEndParsing.
	handler mustBeAtEndAfterParsing
		ifTrue: [	
			inputStream skipSeparators.
			inputStream atEnd
				ifFalse: [self errorExpectedAtEnd]].! !

!XPathParser methodsFor: 'private' stamp: 'monty 1/15/2015 13:54'!
errorExpected: aString
	XPathSyntaxException
		formatSignal: 'Expected {1}'
		with: aString! !

!XPathParser methodsFor: 'private' stamp: 'monty 1/9/2015 07:53'!
errorExpectedAtEnd
	self errorExpected: 'end of input'! !

!XPathParser methodsFor: 'private' stamp: 'monty 1/15/2015 13:54'!
errorExpectedLiteral: anExpectedCharacterOrString butGot: aReceivedCharacterOrString
	XPathSyntaxException
		formatSignal: 'Expected "{1}" but got "{2}"'
		with: anExpectedCharacterOrString
		with: (aReceivedCharacterOrString ifNil: [''])! !

!XPathParser methodsFor: 'private' stamp: 'monty 1/8/2015 05:57'!
errorExpectedName
	self errorExpected: 'name'! !

!XPathParser methodsFor: 'private' stamp: 'monty 1/8/2015 05:57'!
errorExpectedRelativeLocationPath
	self errorExpected: 'relative location path'! !

!XPathParser methodsFor: 'private' stamp: 'monty 1/18/2015 14:06'!
expectNext: aCharacter
	| nextChar |

	((nextChar := inputStream next) == aCharacter)
		ifFalse: [
			self
				errorExpectedLiteral: aCharacter
				butGot: nextChar].
	^ aCharacter.! !

!XPathParser methodsFor: 'private' stamp: 'monty 1/10/2015 08:58'!
expectUpTo: aCharacter
	writeStream reset.
	[inputStream atEnd
		or: [inputStream peek == aCharacter]]
		whileFalse: [writeStream nextPut: inputStream next].
	self expectNext: aCharacter.
	^ writeStream contents.! !

!XPathParser methodsFor: 'accessing' stamp: 'monty 1/8/2015 06:02'!
handler
	^ handler! !

!XPathParser methodsFor: 'accessing' stamp: 'monty 1/8/2015 06:02'!
inputStream
	^ inputStream! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/8/2015 10:20'!
nextEmptyArgumentList
	self
		nextStartArgumentList;
		nextEndArgumentList
! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/8/2015 10:19'!
nextEndArgumentList
	inputStream skipSeparators.
	self expectNext: $).! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/14/2015 03:46'!
nextNCName
	^ self nextNCNameOptional: false! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/15/2015 11:10'!
nextNCNameOptional: aBoolean
	(inputStream hasPushedBackToken
		and: [inputStream pushedBackToken isNCNameToken])
		ifTrue: [^ inputStream nextPushedBackToken].

	writeStream reset.
	(XMLWellFormedParserTokenizer
		nextNCNameFrom: inputStream
		on: writeStream)
		ifFalse: [
			aBoolean
				ifTrue: [^ nil]
				ifFalse: [self errorExpectedName]].
	^ writeStream contents.! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/15/2015 11:17'!
nextName
	inputStream hasPushedBackToken
		ifTrue: [
			inputStream pushedBackToken isNameToken
				ifTrue: [^ inputStream nextPushedBackToken].
			inputStream pushedBackToken isNCNameToken
				ifTrue: [
					writeStream
						reset;
						nextPutAll: inputStream nextPushedBackToken.
					(inputStream peekFor: $:)
						ifTrue: [
							writeStream
								nextPut: $:;
								nextPutAll: self nextNCName].
					^ writeStream contents]].

	writeStream reset.
	(XMLWellFormedParserTokenizer
		nextNameFrom: inputStream
		on: writeStream)
			ifFalse: [self errorExpectedName].
	^ writeStream contents.! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/20/2015 10:46'!
nextNameOptional: aBoolean
	inputStream hasPushedBackToken
		ifTrue: [
			inputStream pushedBackToken isNameToken
				ifTrue: [^ inputStream nextPushedBackToken].
			inputStream pushedBackToken isNCNameToken
				ifTrue: [
					writeStream
						reset;
						nextPutAll: inputStream nextPushedBackToken.
					(inputStream peekFor: $:)
						ifTrue: [
							writeStream
								nextPut: $:;
								nextPutAll: (self nextNCNameOptional: aBoolean)].
					^ writeStream contents]].

	writeStream reset.
	(XMLWellFormedParserTokenizer
		nextNameFrom: inputStream
		on: writeStream)
			ifFalse: [
			aBoolean
				ifTrue: [^ nil]
				ifFalse: [self errorExpectedName]].
	^ writeStream contents.! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/8/2015 10:19'!
nextStartArgumentList
	inputStream skipSeparators.
	self expectNext: $(.! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/10/2015 03:42'!
nextStringLiteral
	^ self nextStringLiteralOptional: false! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/20/2015 10:52'!
nextStringLiteralOptional: aBoolean
	(inputStream peek == $"
		or: [inputStream peek == $'])
		ifTrue: [^ self expectUpTo: inputStream next]
		ifFalse: [
			aBoolean
				ifFalse: [self errorExpected: 'single or double quoted string literal'].
			^ nil]! !

!XPathParser methodsFor: 'initialization' stamp: 'monty 1/14/2015 03:22'!
on: aStringOrStream for: aHandler
	inputStream :=
		(aStringOrStream isStream
			ifTrue: [aStringOrStream asXPathReadStreamAdapter]
			ifFalse: [aStringOrStream readStream asXPathReadStreamAdapter]).
	handler := aHandler.
	writeStream := (String new: 32) writeStream.! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/10/2015 06:07'!
parse
	[self
		startParsing;
		parseInput;
		endParsing]
		on: XPathException
		do: [:error |
			error
				appendPosition: inputStream position;
				pass].
	^ handler parsingResult.! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/8/2015 06:06'!
parseInput
	self subclassResponsibility! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/9/2015 07:59'!
startParsing
	handler handleStartParsing! !

Object subclass: #XPathParserHandler
	instanceVariableNames: 'parsingResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathParserHandler commentStamp: 'monty 1/10/2015 01:54' prior: 0!
An abstract class for XPath parser handlers.!

XPathParserHandler subclass: #XPathExpressionParserHandler
	instanceVariableNames: 'outputStream variableIndex contextNodeVariable contextPositionVariable'
	classVariableNames: 'AxisSpecifierNamesAndSelectors'
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathExpressionParserHandler commentStamp: 'monty 2/10/2015 02:55' prior: 0!
A handler for XPath expression parsers that generates Smalltalk source implementing the XPath expression.!

!XPathExpressionParserHandler class methodsFor: 'private' stamp: 'monty 2/10/2015 22:19'!
axisSpecifierNameAndSelectorPairs
	^ #(
		'ancestor' '%%'
		'ancestor-or-self' '%%~'
		'attribute' '@'
		'child' '/'
		'descendant' '//'
		'descendant-or-self' '//~'
		'following' '>>'
		'following-sibling' '>>>'
		'namespace' '@@'
		'parent' '%'
		'preceding' '<<'
		'preceding-sibling' '<<<'
		'self' '~'
		'%%' '%%'
		'%%~' '%%~'
		'@' '@'
		'>>' '>>'
		'>>>' '>>>'
		'@@' '@@'
		'%' '%'
		'<<' '<<'
		'<<<' '<<<'
		'~' '~'
		)! !

!XPathExpressionParserHandler class methodsFor: 'class initialization' stamp: 'monty 2/10/2015 22:19'!
initialize
	"self initialize"

	self initializeAxisSpecifierNamesAndSelectors! !

!XPathExpressionParserHandler class methodsFor: 'class initialization' stamp: 'monty 2/10/2015 22:19'!
initializeAxisSpecifierNamesAndSelectors
	AxisSpecifierNamesAndSelectors := Dictionary new.
	self axisSpecifierNameAndSelectorPairs
		pairsDo: [:axisSpecifier :selector |
			AxisSpecifierNamesAndSelectors
				at: axisSpecifier asString
				put: selector asString].! !

!XPathExpressionParserHandler methodsFor: 'accessing' stamp: 'monty 1/12/2015 06:01'!
contextNodeVariable
	^ contextNodeVariable! !

!XPathExpressionParserHandler methodsFor: 'accessing' stamp: 'monty 1/12/2015 06:01'!
contextPositionVariable
	^ contextPositionVariable! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/12/2015 05:53'!
decrementVariableNames
	variableIndex := variableIndex - 1.
	self generateVariableNames.! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/11/2015 10:19'!
emitBooleanConversion
	outputStream nextPutAll: ' asXPathBoolean'! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/10/2015 22:14'!
emitEndAttributePredicate
	outputStream nextPutAll: ']]'.
	self emitEndPredicateBlock.! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/11/2015 10:19'!
emitEndBlock
	outputStream nextPut: $]! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/11/2015 10:19'!
emitEndGrouping
	outputStream nextPut: $)! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/20/2015 11:26'!
emitEndPredicateBlock
	self decrementVariableNames.
	outputStream nextPut: $].! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/20/2015 11:15'!
emitQuotedString: aString
	outputStream nextPut: $'.
	"escape ' by outputting another ' before it"
	1 to: aString size do: [:i | | nextChar |
		(nextChar := aString at: i) == $'
			ifTrue: [outputStream nextPut: $'].
		outputStream nextPut: nextChar].
	outputStream nextPut: $'.! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/20/2015 11:34'!
emitStartAttributePredicate: aName
	self emitStartPredicateBlock.
	outputStream
		nextPutAll: contextNodeVariable;
		nextPutAll: ' isElement and:[';
		nextPutAll: contextNodeVariable;
		nextPutAll: ' hasAttributes and:[(';
		nextPutAll: contextNodeVariable;
		nextPutAll: ' attributeAt:'.
	self emitQuotedString: aName.
	outputStream nextPut: $).! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 2/9/2015 20:18'!
emitStartContextBlock
	outputStream
		nextPutAll: '[:';
		nextPutAll: contextNodeVariable;
		nextPutAll: ' :c| |';
		nextPutAll: contextPositionVariable;
		nextPut:$|! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/11/2015 10:19'!
emitStartGrouping
	outputStream nextPut: $(! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/20/2015 11:26'!
emitStartPredicateBlock
	self incrementVariableNames.
	outputStream
		nextPutAll: '??[:';
		nextPutAll: contextNodeVariable;
		nextPutAll: ' :';
		nextPutAll: contextPositionVariable;
		nextPut: $|.! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/11/2015 10:11'!
errorUnrecognizedAxisSpecifier: anAxisSpecifier
	XPathSyntaxException
		formatSignal: 'Unrecognized axis specifier "{1}"'
		with: anAxisSpecifier! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/12/2015 06:01'!
generateVariableNames
	| indexString |

	indexString := variableIndex printString.
	contextNodeVariable := indexString copyWithFirst: $n.
	contextPositionVariable := indexString copyWithFirst: $p.! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 10:50'!
handleAddition
	outputStream nextPutAll: '/+/'! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/10/2015 22:18'!
handleAxisSpecifier: anAxisSpecifier
	outputStream nextPutAll:
		(AxisSpecifierNamesAndSelectors
			at: anAxisSpecifier
			ifAbsent: [self errorUnrecognizedAxisSpecifier: anAxisSpecifier])! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 10:52'!
handleDivision
	outputStream nextPutAll: '///'! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 12:21'!
handleEndAdditiveExpression
	self emitEndGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 10:47'!
handleEndAndExpression
	self emitEndGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 10:55'!
handleEndEqualityExpression
	self emitEndGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 1/14/2015 04:58'!
handleEndFunctionArgument
	outputStream nextPutAll: ');'! !

!XPathExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 1/14/2015 04:57'!
handleEndFunctionCall
	outputStream nextPutAll: 'invoke)'! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 10:55'!
handleEndMultiplicativeExpression
	self emitEndGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 10:27'!
handleEndOrExpression
	self emitEndGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling' stamp: 'monty 1/11/2015 10:05'!
handleEndParsing
	self
		emitEndBlock;
		parsingResult: outputStream contents! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 1/13/2015 11:23'!
handleEndPathExpression
	self emitEndGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 1/20/2015 11:26'!
handleEndPredicate
	self emitEndPredicateBlock! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 11:47'!
handleEndRelationalExpression
	self emitEndGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 10:05'!
handleEndShortCircuitAnd
	self
		emitBooleanConversion;
		emitEndBlock! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 10:05'!
handleEndShortCircuitOr
	self
		emitBooleanConversion;
		emitEndBlock! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/11/2015 00:11'!
handleEndShortCircuited: anInteger
	anInteger > 0
		ifTrue: [
			self emitBooleanConversion.
			anInteger timesRepeat: [self emitEndBlock]]! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/14/2015 03:54'!
handleEndUnaryExpression
	self emitEndGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 11:08'!
handleEndUnionExpression
	self emitEndGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 11:45'!
handleEquals
	outputStream nextPutAll: '/=/'! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 11:48'!
handleGreaterThan
	outputStream nextPutAll: '/>/'! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 11:48'!
handleGreaterThanOrEqualTo
	outputStream nextPutAll: '/>=/'! !

!XPathExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 1/11/2015 12:29'!
handleIntegerPredicate: anIntegerOrFloatString
	outputStream
		nextPutAll: '??';
		nextPutAll: anIntegerOrFloatString! !

!XPathExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 1/12/2015 06:01'!
handleLastFunctionCall
	outputStream
		nextPut: $(;
		nextPutAll: contextNodeVariable;
		nextPutAll: ' parentSize)'! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 11:48'!
handleLessThan
	outputStream nextPutAll: '/</'! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 11:48'!
handleLessThanOrEqualTo
	outputStream nextPutAll: '/<=/'! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 10:51'!
handleModulus
	outputStream nextPutAll: '/\\/'! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 10:50'!
handleMultiplication
	outputStream nextPutAll: '/*/'! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 11:03'!
handleNegation
	outputStream nextPutAll: '-1/*/'! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 11:45'!
handleNotEquals
	outputStream nextPutAll: '/!!=/'! !

!XPathExpressionParserHandler methodsFor: 'handling' stamp: 'monty 1/11/2015 12:13'!
handleNumberLiteral: anIntegerOrFloatString
	outputStream
		space;
		nextPutAll: anIntegerOrFloatString! !

!XPathExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 1/12/2015 06:01'!
handlePositionFunctionCall
	outputStream
		nextPut: $(;
		nextPutAll: contextPositionVariable;
		nextPutAll: ' ifNil:[';
		nextPutAll: contextNodeVariable;
		nextPutAll: ' position])'! !

!XPathExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 1/20/2015 11:33'!
handlePredicateAttribute: aName equalsStringLiteral: aStringLiteral
	self emitStartAttributePredicate: aName.
	outputStream nextPut: $=.
	self
		emitQuotedString: aStringLiteral;
		emitEndAttributePredicate.! !

!XPathExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 1/20/2015 11:33'!
handlePredicateAttribute: aName notEqualsStringLiteral: aStringLiteral
	self emitStartAttributePredicate: aName.
	outputStream nextPutAll: '~='.
	self
		emitQuotedString: aStringLiteral;
		emitEndAttributePredicate.! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/4/2015 06:45'!
handleStartAbsoluteLocationPath
	outputStream
		nextPutAll: contextNodeVariable;
		nextPutAll: ' documentRoot'! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 12:21'!
handleStartAdditiveExpression
	self emitStartGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 10:47'!
handleStartAndExpression
	self emitStartGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 11:45'!
handleStartEqualityExpression
	self emitStartGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 1/14/2015 04:58'!
handleStartFunctionArgument
	outputStream nextPutAll: 'push: ('! !

!XPathExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 1/12/2015 06:01'!
handleStartFunctionCall: aFunctionName
	outputStream
		nextPutAll: '((c function: ''';
		nextPutAll: aFunctionName;
		nextPutAll: ''' contextNode: ';
		nextPutAll: contextNodeVariable;
		nextPut: $)! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 12:04'!
handleStartMultiplicativeExpression
	self emitStartGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 10:27'!
handleStartOrExpression
	self emitStartGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling' stamp: 'monty 1/12/2015 05:56'!
handleStartParsing
	outputStream := (String new: 128) writeStream.
	variableIndex := 1.
	self
		generateVariableNames;
		emitStartContextBlock.! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 1/13/2015 11:23'!
handleStartPathExpression
	self emitStartGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 1/20/2015 11:25'!
handleStartPredicate
	self emitStartPredicateBlock! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 11:47'!
handleStartRelationalExpression
	self emitStartGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 1/14/2015 02:44'!
handleStartRelativeLocationPath
	outputStream nextPutAll: contextNodeVariable! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 12:16'!
handleStartShortCircuitAnd
	self emitBooleanConversion.
	outputStream nextPutAll: ' and:['.! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2015 12:16'!
handleStartShortCircuitOr
	self emitBooleanConversion.
	outputStream nextPutAll: ' or:['.! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/14/2015 03:54'!
handleStartUnaryExpression
	self emitStartGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 11:08'!
handleStartUnionExpression
	self emitStartGrouping! !

!XPathExpressionParserHandler methodsFor: 'handling' stamp: 'monty 1/20/2015 11:15'!
handleStringLiteral: aString
	self emitQuotedString: aString! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/13/2015 10:51'!
handleSubtraction
	outputStream nextPutAll: '/-/'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 1/15/2015 03:34'!
handleTestForAnyLocalNameAfterPrefix: aPrefix
	outputStream
		nextPutAll: '(c testForAnyLocalNameAfterPrefix:''';
		nextPutAll: aPrefix;
		nextPutAll: ''')'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 1/14/2015 04:30'!
handleTestForAnyName
	outputStream nextPutAll: '[:n|n isPrincipalNode]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 1/15/2015 03:27'!
handleTestForAnyPrefixBeforeLocalName: aLocalName
	outputStream
		nextPutAll: '[:n|n isPrincipalNode and:[n localName=''';
		nextPutAll: aLocalName;
		nextPutAll: ''']]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 1/14/2015 04:16'!
handleTestForCommentType
	outputStream nextPutAll: '[:n|n isComment]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 1/15/2015 03:32'!
handleTestForLocalName: aLocalName
	outputStream
		nextPutAll: '(c testForLocalName:''';
		nextPutAll: aLocalName;
		nextPutAll: ''')'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 1/15/2015 10:18'!
handleTestForNamespaceURI: aNamespaceUri localName: aLocalName
	outputStream
		nextPutAll: '[:n|no isPrincipalNode and:[n namespaceURI=''';
		nextPutAll: aNamespaceUri;
		nextPutAll: '''and:[n localName=''';
		nextPutAll: aLocalName;
		nextPutAll: ''']]]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 1/14/2015 03:31'!
handleTestForNodeType
	outputStream nextPutAll: '[:n|true]'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 1/15/2015 03:27'!
handleTestForPIType: aName
	aName isEmpty
		ifTrue: [outputStream nextPutAll: '[:n|n isPI]']
		ifFalse: [
			outputStream
				nextPutAll: '[:n|n isPI and:[n target=''';
				nextPutAll: aName;
				nextPutAll: ''']]']! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 1/15/2015 03:26'!
handleTestForPrefix: aPrefix localName: aLocalName
	outputStream
		nextPutAll: '(c testForPrefix:''';
		nextPutAll: aPrefix;
		nextPutAll: '''localName:''';
		nextPutAll: aLocalName;
		nextPutAll: ''')'! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 1/14/2015 04:16'!
handleTestForTextType
	outputStream nextPutAll: '[:n|n isStringNode]'! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/13/2015 11:06'!
handleUnion
	outputStream nextPut: $|! !

!XPathExpressionParserHandler methodsFor: 'handling' stamp: 'monty 1/17/2015 04:50'!
handleVariableReference: aName
	outputStream
		nextPutAll: '(c variableAt: ''';
		nextPutAll: aName;
		nextPutAll: ''')'! !

!XPathExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/12/2015 05:52'!
incrementVariableNames
	variableIndex := variableIndex + 1.
	self generateVariableNames.! !

!XPathExpressionParserHandler methodsFor: 'accessing' stamp: 'monty 1/11/2015 10:19'!
outputStream
	^ outputStream! !

XPathParserHandler subclass: #XPathFunctionPrototypeParserHandler
	instanceVariableNames: 'function returnType functionName minArguments maxArguments argumentTypes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

XPathFunctionPrototypeParserHandler class
	instanceVariableNames: 'classesByTypeName'!

!XPathFunctionPrototypeParserHandler commentStamp: 'monty 2/10/2015 20:39' prior: 0!
A handler for function prototype parsers that initializes an XPathFunction class with the function name, return type, and number and types of arguments specified by the prototype.!

XPathFunctionPrototypeParserHandler class
	instanceVariableNames: 'classesByTypeName'!

!XPathFunctionPrototypeParserHandler class methodsFor: 'private' stamp: 'monty 1/23/2015 19:48'!
classesByTypeName
	^ classesByTypeName
		ifNil: [
			(classesByTypeName := Dictionary new)
				at: 'object' put: Object;
				at: 'boolean' put: Boolean;
				at: 'string' put: String;
				at: 'number' put: Number;
				at: 'node-set' put: XPathNodeSet;
				yourself]! !

!XPathFunctionPrototypeParserHandler class methodsFor: 'private' stamp: 'monty 1/23/2015 19:47'!
classesByTypeNameAt: aTypeName ifAbsent: aBlock
	^ self classesByTypeName
		at: aTypeName
		ifAbsent: aBlock! !

!XPathFunctionPrototypeParserHandler class methodsFor: 'instance creation' stamp: 'monty 1/9/2015 07:12'!
function: aFunction
	^ self new setFunction: aFunction! !

!XPathFunctionPrototypeParserHandler methodsFor: 'private' stamp: 'monty 1/9/2015 07:34'!
addArgumentTypeFor: aTypeName
	argumentTypes addLast: (self classForTypeName: aTypeName)! !

!XPathFunctionPrototypeParserHandler methodsFor: 'private' stamp: 'monty 1/23/2015 12:42'!
classForTypeName: aTypeName
	^ self class
		classesByTypeNameAt: aTypeName
		ifAbsent: [self errorUnrecognizedTypeName: aTypeName]! !

!XPathFunctionPrototypeParserHandler methodsFor: 'private' stamp: 'monty 1/9/2015 07:14'!
errorUnrecognizedTypeName: aTypeName
	XPathTypeException
		formatSignal: 'Unrecognized type name "{1}"'
		with: aTypeName! !

!XPathFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:33'!
handleArgument: anArgument
	minArguments := minArguments + 1.
	maxArguments := maxArguments + 1.
	self addArgumentTypeFor: anArgument.! !

!XPathFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:19'!
handleEndParsing
	function
		setReturnType: returnType
		functionName: functionName
		minArguments: minArguments
		maxArguments: maxArguments
		argumentTypes: argumentTypes! !

!XPathFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:17'!
handleFunctionName: aName
	functionName := aName! !

!XPathFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:33'!
handleOptionalArgument: anArgument
	maxArguments := maxArguments + 1.
	self addArgumentTypeFor: anArgument.! !

!XPathFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:15'!
handleReturnType: aReturnType
	returnType := self classForTypeName: aReturnType! !

!XPathFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:32'!
handleUnboundedArgument: anArgument
	maxArguments := nil.
	self addArgumentTypeFor: anArgument.! !

!XPathFunctionPrototypeParserHandler methodsFor: 'testing' stamp: 'monty 1/9/2015 07:26'!
hasOptionalArgument
	^ minArguments < maxArguments
	! !

!XPathFunctionPrototypeParserHandler methodsFor: 'testing' stamp: 'monty 1/9/2015 07:27'!
hasUnboundedArgument
	^ maxArguments isNil! !

!XPathFunctionPrototypeParserHandler methodsFor: 'initialization' stamp: 'monty 1/9/2015 07:11'!
setFunction: aFunction
	function := aFunction.
	maxArguments := 0.
	minArguments := 0.
	argumentTypes := OrderedCollection new.! !

XPathParserHandler subclass: #XPathNodeTestParserHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNodeTestParserHandler commentStamp: 'monty 1/10/2015 01:22' prior: 0!
An abstract handler for node test parsers.!

XPathNodeTestParserHandler subclass: #XPathExpressionNodeTestParserHandler
	instanceVariableNames: 'currentAxis expressionParserHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathExpressionNodeTestParserHandler commentStamp: 'monty 2/10/2015 20:39' prior: 0!
A handler used by the expression parser for parsing node tests that are part of location path steps.!

!XPathExpressionNodeTestParserHandler class methodsFor: 'instance creation' stamp: 'monty 1/13/2015 11:43'!
currentAxis: anAxis expressionParserHandler: anExpressionParserHandler
	^ self new
		setCurrentAxis: anAxis
		expressionParserHandler: anExpressionParserHandler! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/21/2015 18:30'!
handleEmptyTest
	self parsingResult: false! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/13/2015 12:42'!
handleStartParsing
	self parsingResult: false! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/15/2015 03:33'!
handleTestForAnyLocalNameAfterPrefix: aPrefix
	self startNodeTest.
	expressionParserHandler handleTestForAnyLocalNameAfterPrefix: aPrefix.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 04:29'!
handleTestForAnyName
	self startNodeTest.
	expressionParserHandler handleTestForAnyName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/15/2015 03:18'!
handleTestForAnyPrefixBeforeLocalName: aLocalName
	self startNodeTest.
	expressionParserHandler handleTestForAnyPrefixBeforeLocalName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 04:27'!
handleTestForCommentType
	self startNodeTest.
	expressionParserHandler handleTestForCommentType.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/15/2015 03:31'!
handleTestForLocalName: aLocalName
	self startNodeTest.
	expressionParserHandler handleTestForLocalName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/15/2015 10:19'!
handleTestForNamespaceURI: aNamespaceUri localName: aLocalName
	self startNodeTest.
	expressionParserHandler
		handleTestForNamespaceURI: aNamespaceUri
		localName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 04:27'!
handleTestForNodeType
	self startNodeTest.
	expressionParserHandler handleTestForNodeType.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 04:26'!
handleTestForPIType: aName
	self startNodeTest.
	expressionParserHandler handleTestForPIType: aName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/15/2015 03:23'!
handleTestForPrefix: aPrefix localName: aLocalName
	self startNodeTest.
	expressionParserHandler
		handleTestForPrefix: aPrefix
		localName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 04:27'!
handleTestForTextType
	self startNodeTest.
	expressionParserHandler handleTestForTextType.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'testing' stamp: 'monty 2/10/2015 02:26'!
mustBeAtEndAfterParsing
	^ false! !

!XPathExpressionNodeTestParserHandler methodsFor: 'initialization' stamp: 'monty 1/13/2015 11:43'!
setCurrentAxis: anAxis expressionParserHandler: anExpressionParserHandler
	currentAxis := anAxis.
	expressionParserHandler := anExpressionParserHandler.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'private' stamp: 'monty 1/14/2015 04:26'!
startNodeTest
	self parsingResult: true.
	currentAxis handleWith: expressionParserHandler.! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 02:51'!
handleEmptyTest! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 02:50'!
handleTestForAnyLocalNameAfterPrefix: aPrefix! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 02:50'!
handleTestForAnyName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 02:50'!
handleTestForAnyPrefixBeforeLocalName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 02:52'!
handleTestForCommentType! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/15/2015 03:30'!
handleTestForLocalName: aName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 02:53'!
handleTestForNamespaceURI: aNamespaceUri localName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 02:53'!
handleTestForNodeType! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 02:54'!
handleTestForPIType: aName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 02:53'!
handleTestForPrefix: aPrefix localName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 02:50'!
handleTestForTextType! !

XPathNodeTestParserHandler subclass: #XPathStringNodeTestParserHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathStringNodeTestParserHandler commentStamp: 'monty 2/10/2015 02:54' prior: 0!
A handler for node tests that occur in string arguments to the abbreviated axis selectors. It converts them to node test blocks.!

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 02:51'!
handleEmptyTest
	self errorExpected: 'XPath node test'! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 02:50'!
handleTestForAnyLocalNameAfterPrefix: aPrefix
	self parsingResult:
		[:node |
			node isPrincipalNode
				and: [node prefix = aPrefix]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 02:50'!
handleTestForAnyName
	self parsingResult: [:node | node isPrincipalNode]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 02:50'!
handleTestForAnyPrefixBeforeLocalName: aLocalName
	self parsingResult:
		[:node |
			node isPrincipalNode
				and: [node localName = aLocalName]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 02:52'!
handleTestForCommentType
	self parsingResult: [:node | node isComment]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/15/2015 03:31'!
handleTestForLocalName: aLocalName
	self parsingResult:
		[:node |
			node isPrincipalNode
				and: [node localName = aLocalName]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 02:53'!
handleTestForNamespaceURI: aNamespaceUri localName: aLocalName
	self parsingResult:
		[:node |
			node isPrincipalNode
				and: [node namespaceURI = aNamespaceUri
					and: [node localName = aLocalName]]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 02:53'!
handleTestForNodeType
	self parsingResult: [:node | true]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/15/2015 03:28'!
handleTestForPIType: aName
	aName isEmpty
		ifTrue: [self parsingResult: [:node | node isPI]]
		ifFalse: [
			self parsingResult:
				[:node |
					node isPI
						and: [node target = aName]]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 02:53'!
handleTestForPrefix: aPrefix localName: aLocalName
	self parsingResult:
		[:node |
			node isPrincipalNode
				and: [node localName = aLocalName
					and: [node prefix = aPrefix]]]! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/14/2015 02:50'!
handleTestForTextType
	self parsingResult: [:node | node isStringNode]! !

!XPathParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:18'!
handleEndParsing! !

!XPathParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:18'!
handleStartParsing! !

!XPathParserHandler methodsFor: 'testing' stamp: 'monty 2/10/2015 02:26'!
mustBeAtEndAfterParsing
	^ true! !

!XPathParserHandler methodsFor: 'accessing' stamp: 'monty 1/10/2015 06:10'!
parsingResult
	^ parsingResult! !

!XPathParserHandler methodsFor: 'accessing' stamp: 'monty 1/10/2015 06:13'!
parsingResult: aParsingResult
	parsingResult := aParsingResult! !

Object subclass: #XPathPushedBackToken
	instanceVariableNames: 'token position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Streams'!

!XPathPushedBackToken commentStamp: 'monty 1/15/2015 11:06' prior: 0!
This is a class for storing pushed-back tokens so they can be quickly read again.!

XPathPushedBackToken subclass: #XPathPushedBackNCNameToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Streams'!

!XPathPushedBackNCNameToken commentStamp: 'monty 1/10/2015 01:22' prior: 0!
A pushed-back non-qualified name token, to be read by nextNCName.!

!XPathPushedBackNCNameToken methodsFor: 'testing' stamp: 'monty 1/8/2015 07:21'!
isNCNameToken
	^ true! !

XPathPushedBackToken subclass: #XPathPushedBackNameToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Streams'!

!XPathPushedBackNameToken commentStamp: 'monty 1/10/2015 01:22' prior: 0!
A pushed-back name token, to be read by nextName.!

!XPathPushedBackNameToken methodsFor: 'testing' stamp: 'monty 1/8/2015 07:21'!
isNameToken
	^ true! !

!XPathPushedBackToken class methodsFor: 'instance creation' stamp: 'monty 1/8/2015 07:21'!
token: aToken position: aPosition
	^ self new
		setToken: aToken
		position: aPosition! !

!XPathPushedBackToken methodsFor: 'testing' stamp: 'monty 1/8/2015 07:19'!
isNCNameToken
	^ false! !

!XPathPushedBackToken methodsFor: 'testing' stamp: 'monty 1/8/2015 07:19'!
isNameToken
	^ false! !

!XPathPushedBackToken methodsFor: 'accessing' stamp: 'monty 1/9/2015 08:18'!
position
	^ position! !

!XPathPushedBackToken methodsFor: 'initialization' stamp: 'monty 1/8/2015 07:22'!
setToken: aToken position: aPosition
	token := aToken.
	position := aPosition.! !

!XPathPushedBackToken methodsFor: 'accessing' stamp: 'monty 1/14/2015 15:07'!
token
	^ token! !

Object subclass: #XPathReadStreamAdapter
	instanceVariableNames: 'stream pushedBackToken'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Streams'!

!XPathReadStreamAdapter commentStamp: 'monty 2/10/2015 03:03' prior: 0!
This class is an adapter for positionable read streams that wraps them to be safe to send messages like next and peek when atEnd and supports efficient push back using token objects.!

!XPathReadStreamAdapter class methodsFor: 'instance creation' stamp: 'monty 1/8/2015 02:51'!
on: aStream
	^ self new on: aStream! !

!XPathReadStreamAdapter methodsFor: 'converting' stamp: 'monty 1/14/2015 03:19'!
asXPathReadStreamAdapter
	^ self! !

!XPathReadStreamAdapter methodsFor: 'testing' stamp: 'monty 1/8/2015 02:50'!
atEnd
	^ stream atEnd! !

!XPathReadStreamAdapter methodsFor: 'testing' stamp: 'monty 1/9/2015 08:02'!
hasPushedBackToken
	^ pushedBackToken notNil
		and: [pushedBackToken position = self position]! !

!XPathReadStreamAdapter methodsFor: 'testing' stamp: 'monty 1/10/2015 01:20'!
isStream
	^ true! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/8/2015 03:11'!
next
	stream atEnd
		ifTrue: [^ nil]
		ifFalse: [^ stream next]! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 2/10/2015 02:29'!
nextPushedBackToken
	| token |

	token := pushedBackToken token.
	self position: self position + token size.
	pushedBackToken := nil.
	^ token.! !

!XPathReadStreamAdapter methodsFor: 'initialization' stamp: 'monty 1/8/2015 02:52'!
on: aStream
	stream := aStream! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/8/2015 03:11'!
peek
	stream atEnd
		ifTrue: [^ nil]
		ifFalse: [^ stream peek]! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 2/10/2015 02:29'!
peekFor: aCharacter
	(stream atEnd not
		and: [stream peek == aCharacter])
		ifTrue: [
			stream next.
			^ true]
		ifFalse: [^ false]! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/8/2015 03:10'!
peekForAll: aString
	| oldPosition |

	(stream atEnd not
		and: [stream peek == (aString at: 1)])
		ifFalse: [^ false].

	oldPosition := stream position.
	stream next.
	2 to: aString size do: [:i |
		(stream atEnd not
			and: [stream next == (aString at: i)])
			ifFalse: [
				stream position: oldPosition.
				^ false]].
	^ true.! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/8/2015 02:50'!
position
	^ stream position! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/8/2015 02:50'!
position: aPosition
	stream position: aPosition! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/9/2015 11:33'!
pushBackToken: aPushedBackToken
	pushedBackToken := aPushedBackToken.
	self position: aPushedBackToken position.! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/9/2015 08:03'!
pushedBackToken
	^ pushedBackToken! !

!XPathReadStreamAdapter methodsFor: 'streaming' stamp: 'monty 1/19/2015 13:51'!
skipBack
	"does not peek like #back"
	stream position: stream position - 1! !

!XPathReadStreamAdapter methodsFor: 'streaming' stamp: 'monty 1/8/2015 07:38'!
skipSeparators
	stream skipSeparators! !

Object subclass: #XPathSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

XPathSortOrder class
	instanceVariableNames: 'instance'!

!XPathSortOrder commentStamp: 'monty 2/10/2015 01:28' prior: 0!
Abstract class for node sort orders.!

XPathSortOrder class
	instanceVariableNames: 'instance'!

XPathSortOrder subclass: #XPathDocumentSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathDocumentSortOrder commentStamp: 'monty 2/10/2015 03:47' prior: 0!
A sort order for nodes in document order.!

!XPathDocumentSortOrder methodsFor: 'converting' stamp: 'monty 1/26/2015 20:29'!
asDocumentSortOrder
	^ self! !

!XPathDocumentSortOrder methodsFor: 'private' stamp: 'monty 2/3/2015 17:28'!
documentOrderOn: aNodeSet do: aBlock
	aNodeSet do: aBlock! !

!XPathDocumentSortOrder methodsFor: 'sorting' stamp: 'monty 1/30/2015 17:12'!
documentOrderSort: aNodeSet
	"already in document order"! !

!XPathDocumentSortOrder methodsFor: 'accessing' stamp: 'monty 2/3/2015 01:25'!
firstInDocumentOrderFrom: aNodeSet
	^ aNodeSet first! !

!XPathDocumentSortOrder methodsFor: 'private' stamp: 'monty 2/3/2015 17:29'!
reverseDocumentOrderOn: aNodeSet do: aBlock
	aNodeSet reverseDo: aBlock! !

!XPathDocumentSortOrder methodsFor: 'sorting' stamp: 'monty 2/5/2015 06:31'!
reverseDocumentOrderSort: aNodeSet
	aNodeSet
		reverseInPlace;
		sortOrder: XPathReverseDocumentSortOrder new! !

XPathDocumentSortOrder subclass: #XPathElementMetaNodeDocumentSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathElementMetaNodeDocumentSortOrder commentStamp: 'monty 2/10/2015 03:48' prior: 0!
A sort order for attribute or namespace nodes in document order.!

!XPathElementMetaNodeDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/5/2015 04:33'!
attributeAxisOn: aNodeSet select: aNodeTestBlock
	^ aNodeSet copyEmpty! !

!XPathElementMetaNodeDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/3/2015 00:37'!
childAxisOn: aNodeSet select: aNodeTestBlock
	^ aNodeSet copyEmpty! !

!XPathElementMetaNodeDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/3/2015 00:37'!
descendantAxisOn: aNodeSet select: aNodeTestBlock
	^ aNodeSet copyEmpty! !

!XPathElementMetaNodeDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/5/2015 04:34'!
descendantOrSelfAxisOn: aNodeSet select: aNodeTestBlock
	"has no descendants"
	^ self
		selfAxisOn: aNodeSet
		select: aNodeTestBlock! !

!XPathElementMetaNodeDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/3/2015 00:40'!
followingAxisOn: aNodeSet select: aNodeTestBlock
	^ aNodeSet copyEmpty! !

!XPathElementMetaNodeDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/3/2015 00:40'!
followingSiblingAxisOn: aNodeSet select: aNodeTestBlock
	^ aNodeSet copyEmpty! !

!XPathElementMetaNodeDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/5/2015 04:33'!
namespaceAxisOn: aNodeSet select: aNodeTestBlock
	^ aNodeSet copyEmpty! !

!XPathElementMetaNodeDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/3/2015 00:39'!
precedingAxisOn: aNodeSet select: aNodeTestBlock
	^ aNodeSet copyEmpty! !

!XPathElementMetaNodeDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/3/2015 00:40'!
precedingSiblingAxisOn: aNodeSet select: aNodeTestBlock
	^ aNodeSet copyEmpty! !

XPathDocumentSortOrder subclass: #XPathLevelDocumentSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathLevelDocumentSortOrder commentStamp: 'monty 2/10/2015 03:48' prior: 0!
A sort order for nodes in document order all having the same parent, or the children of nodes having the same parent, and so on.!

!XPathLevelDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/3/2015 17:23'!
childAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		childAxisOnSiblings: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/5/2015 02:30'!
followingAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		followingAxisOnSiblings: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/3/2015 17:25'!
followingSiblingAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		followingSiblingAxisOnSiblings: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/4/2015 19:29'!
precedingAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		precedingAxisOnSiblings: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/3/2015 17:31'!
precedingSiblingAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		precedingSiblingAxisOnSiblings: aNodeSet
		select: aNodeTestBlock! !

XPathSortOrder subclass: #XPathReverseDocumentSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathReverseDocumentSortOrder commentStamp: 'monty 2/10/2015 01:28' prior: 0!
A sort order for node in reverse document order.!

XPathReverseDocumentSortOrder subclass: #XPathLevelReverseDocumentSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathLevelReverseDocumentSortOrder commentStamp: 'monty 2/10/2015 03:48' prior: 0!
A sort order for nodes in reverse document order all having the same parent, or the children of nodes having the same parent, and so on.!

!XPathLevelReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/3/2015 17:30'!
childAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		childAxisOnSiblings: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/5/2015 02:31'!
followingAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		followingAxisOnSiblings: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/3/2015 17:30'!
followingSiblingAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		followingSiblingAxisOnSiblings: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/5/2015 02:31'!
precedingAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		precedingAxisOnSiblings: aNodeSet
		select: aNodeTestBlock! !

!XPathLevelReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 2/3/2015 17:32'!
precedingSiblingAxisOn: aNodeSet select: aNodeTestBlock
	^ self
		precedingSiblingAxisOnSiblings: aNodeSet
		select: aNodeTestBlock! !

!XPathReverseDocumentSortOrder methodsFor: 'private' stamp: 'monty 1/30/2015 19:18'!
documentOrderOn: aNodeSet do: aBlock
	aNodeSet reverseDo: aBlock! !

!XPathReverseDocumentSortOrder methodsFor: 'sorting' stamp: 'monty 2/3/2015 01:32'!
documentOrderSort: aNodeSet
	aNodeSet
		reverseInPlace;
		sortOrder: XPathDocumentSortOrder new! !

!XPathReverseDocumentSortOrder methodsFor: 'accessing' stamp: 'monty 2/3/2015 01:25'!
firstInDocumentOrderFrom: aNodeSet
	^ aNodeSet last! !

!XPathReverseDocumentSortOrder methodsFor: 'private' stamp: 'monty 2/3/2015 17:28'!
reverseDocumentOrderOn: aNodeSet do: aBlock
	aNodeSet do: aBlock! !

!XPathReverseDocumentSortOrder methodsFor: 'sorting' stamp: 'monty 2/5/2015 06:30'!
reverseDocumentOrderSort: aNodeSet! !

!XPathSortOrder class methodsFor: 'instance creation' stamp: 'monty 1/26/2015 13:42'!
new
	"these classes are only initialized once for performance"
	^ instance ifNil: [instance := self basicNew initialize]! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/12/2015 00:56'!
ancestorAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each | | totalAdded ancestor |
		totalAdded := 0.
		ancestor := each parent.
		[ancestor isNil
			or: [copy includes: ancestor]]
			whileFalse: [
				(aNodeTestBlock value: ancestor)
					ifTrue: [
						copy addLast: ancestor.
						totalAdded := totalAdded + 1].
				ancestor := ancestor parent].
		totalAdded > 1
			ifTrue: [
				copy
					reverseInPlaceFrom: (copy size - totalAdded) + 1
					to: copy size]].
	^ copy
		reverseInPlace;
		sortOrder: XPathReverseDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/12/2015 00:56'!
ancestorOrSelfAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each | | totalAdded ancestor |
		totalAdded := 0.
		((copy includes: each) not
			and: [aNodeTestBlock value: each])
			ifTrue: [
				copy addLast: each.
				totalAdded := 1].
		ancestor := each parent.
		[ancestor isNil
			or: [copy includes: ancestor]]
			whileFalse: [
				(aNodeTestBlock value: ancestor)
					ifTrue: [
						copy addLast: ancestor.
						totalAdded := totalAdded + 1].
				ancestor := ancestor parent].
		totalAdded > 1
			ifTrue: [
				copy
					reverseInPlaceFrom: (copy size - totalAdded) + 1
					to: copy size]].
	^ copy
		reverseInPlace;
		sortOrder: XPathReverseDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'converting' stamp: 'monty 1/26/2015 20:28'!
asDocumentSortOrder
	^ XPathDocumentSortOrder new! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/10/2015 01:04'!
attributeAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each |
		(each isElement
			and: [each hasAttributes])
			ifTrue: [
				each attributeNodesDo: [:attribute |
					(aNodeTestBlock value: attribute)
						ifTrue: [copy addLast: attribute]]]].
	^ copy sortOrder: XPathElementMetaNodeDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/4/2015 03:58'!
childAxisOn: aNodeSet select: aNodeTestBlock
	| copy nodesWithChildren |

	copy := aNodeSet copyEmpty.
	nodesWithChildren := OrderedCollection new.
	self documentOrderOn: aNodeSet do: [:each |
		each hasChildren
			ifTrue: [nodesWithChildren addLast: each]].
	[nodesWithChildren notEmpty]
		whileTrue: [
			self
				nextChildrenInDocumentOrderFrom: nodesWithChildren
				select: aNodeTestBlock
				into: copy].
	^ copy sortOrder: XPathDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 2/10/2015 01:12'!
childAxisOnSiblings: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each |
		each hasChildren
			ifTrue: [
				each nodesDo: [:node |
					(aNodeTestBlock value: node)
						ifTrue: [copy addLast: node]]]].
	^ copy sortOrder: XPathLevelDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'copying' stamp: 'monty 2/3/2015 03:47'!
copy
	^ self! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/4/2015 06:39'!
descendantAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each |
		each descendentNodesDetect: [:descendant |
			(copy includes: descendant)
				ifTrue: [true]
				ifFalse: [
					(aNodeTestBlock value: descendant)
						ifTrue: [copy addLast: descendant].
					false]]].
	^ copy sortOrder: XPathDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/4/2015 06:39'!
descendantOrSelfAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each |
		each allNodesDetect: [:descendant |
			(copy includes: descendant)
				ifTrue: [true]
				ifFalse: [
					(aNodeTestBlock value: descendant)
						ifTrue: [copy addLast: descendant].
					false]]].
	^ copy sortOrder: XPathDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 2/3/2015 17:28'!
documentOrderOn: aNodeSet do: aBlock
	self subclassResponsibility! !

!XPathSortOrder methodsFor: 'sorting' stamp: 'monty 1/26/2015 18:43'!
documentOrderSort: aNodeSet
	self subclassResponsibility! !

!XPathSortOrder methodsFor: 'accessing' stamp: 'monty 2/3/2015 01:24'!
firstInDocumentOrderFrom: aNodeSet
	self subclassResponsibility! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/8/2015 02:59'!
followingAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	aNodeSet documentOrderOn: aNodeSet do: [:each |
		(copy includes: each)
			ifFalse: [
				each followingNodesDo: [:followingNode |
					(aNodeTestBlock value: followingNode)
						ifTrue: [copy addLast: followingNode]]]].
	^ copy sort.
! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 2/4/2015 19:32'!
followingAxisOnSiblings: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each | | lastParentAddedFrom |
		(lastParentAddedFrom notNil
			and: [each parent = lastParentAddedFrom])
			ifFalse: [
				each followingNodesDo: [:sibling | 
					(aNodeTestBlock value: sibling)
						ifTrue: [copy addLast: sibling]].
				lastParentAddedFrom := each]].
	^ copy sortOrder: XPathDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/8/2015 02:58'!
followingSiblingAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each |
		(copy includes: each)
			ifFalse: [
				each followingSiblingNodesDo: [:sibling |
					(aNodeTestBlock value: sibling)
						ifTrue: [copy addLast: sibling]]]].
	^ copy sort.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 2/10/2015 01:12'!
followingSiblingAxisOnSiblings: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each | | lastParentAddedFrom |
		(lastParentAddedFrom notNil
			and: [each parent = lastParentAddedFrom])
			ifFalse: [
				each followingSiblingNodesDo: [:sibling | 
					(aNodeTestBlock value: sibling)
						ifTrue: [copy addLast: sibling]].
				lastParentAddedFrom := each]].
	^ copy sortOrder: XPathLevelDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/10/2015 01:04'!
namespaceAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each |
		(each isElement
			and: [each hasNamespaceNodes])
			ifTrue: [
				each namespaceNodesDo: [:namespace |
					(aNodeTestBlock value: namespace)
						ifTrue: [copy addLast: namespace]]]].
	^ copy sortOrder: XPathElementMetaNodeDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 2/4/2015 06:07'!
nextChildrenInDocumentOrderFrom: aNodeWithChildrenCollection select: aNodeTestBlock into: aNodeSet
	| nodeWithChildren nextNodeWithChildren |

	nodeWithChildren := aNodeWithChildrenCollection removeFirst.
	nextNodeWithChildren := aNodeWithChildrenCollection at: 1 ifAbsent: nil.
	(nextNodeWithChildren isNil
		or: [nextNodeWithChildren parent = nodeWithChildren parent])
		ifTrue: [
			nodeWithChildren nodesDo: [:each |
				(aNodeTestBlock value: each)
					ifTrue: [aNodeSet addLast: each]]]
		ifFalse: [| totalChildren totalChildrenVisited |
			totalChildren := nodeWithChildren nodes size.
			totalChildrenVisited := 0.
			nodeWithChildren descendentNodesDetect: [:each |
				each parent = nodeWithChildren
					ifTrue: [
						(aNodeTestBlock value: each)
							ifTrue: [aNodeSet addLast: each].
						totalChildrenVisited := totalChildrenVisited + 1].
				each = nextNodeWithChildren
					ifTrue: [
						self
							nextChildrenInDocumentOrderFrom: aNodeWithChildrenCollection
							select: aNodeTestBlock
							into: aNodeSet.
						nextNodeWithChildren := aNodeWithChildrenCollection at: 1 ifAbsent: nil].
				totalChildrenVisited = totalChildren
					or: [nextNodeWithChildren isNil]].
			(totalChildrenVisited = totalChildren)
				ifFalse: [
					totalChildrenVisited + 1 to: totalChildren do: [:i | | node |
						node := nodeWithChildren nodeAt: i.
						(aNodeTestBlock value: node)
							ifTrue: [aNodeSet addLast: node]]]].! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/1/2015 01:38'!
parentAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each | | parent |
		(each hasParent
			and: [(copy includes: (parent := each parent)) not
				and: [aNodeTestBlock value: parent]])
			ifTrue: [copy addLast: parent]].
	^ copy sortOrder: self asDocumentSortOrder.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/8/2015 03:00'!
precedingAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	aNodeSet reverseDocumentOrderOn: aNodeSet do: [:each |
		(copy includes: each)
			ifFalse: [
				each precedingNodesDo: [:precedingNode |
					(aNodeTestBlock value: precedingNode)
						ifTrue: [copy addLast: precedingNode]]]].
	^ copy reverseSort.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 2/4/2015 19:30'!
precedingAxisOnSiblings: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self reverseDocumentOrderOn: aNodeSet do: [:each | | lastParentAddedFrom |
		(lastParentAddedFrom notNil
			and: [each parent = lastParentAddedFrom])
			ifFalse: [
				each precedingNodesDo: [:sibling | 
					(aNodeTestBlock value: sibling)
						ifTrue: [copy addLast: sibling]].
				lastParentAddedFrom := each]].
	^ copy sortOrder: XPathReverseDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/8/2015 03:00'!
precedingSiblingAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	aNodeSet reverseDocumentOrderOn: aNodeSet do: [:each |
		(copy includes: each)
			ifFalse: [
				each precedingSiblingNodesDo: [:sibling |
					(aNodeTestBlock value: sibling)
						ifTrue: [copy addLast: sibling]]]].
	^ copy reverseSort.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 2/10/2015 01:13'!
precedingSiblingAxisOnSiblings: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self reverseDocumentOrderOn: aNodeSet do: [:each | | lastParentAddedFrom |
		(lastParentAddedFrom notNil
			and: [each parent = lastParentAddedFrom])
			ifFalse: [
				each precedingSiblingNodesDo: [:sibling | 
					(aNodeTestBlock value: sibling)
						ifTrue: [copy addLast: sibling]].
				lastParentAddedFrom := each]].
	^ copy sortOrder: XPathLevelReverseDocumentSortOrder new.! !

!XPathSortOrder methodsFor: 'private' stamp: 'monty 2/3/2015 17:27'!
reverseDocumentOrderOn: aNodeSet do: aBlock
	self subclassResponsibility! !

!XPathSortOrder methodsFor: 'sorting' stamp: 'monty 2/5/2015 06:30'!
reverseDocumentOrderSort: aNodeSet
	self subclassResponsibility! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 2/1/2015 01:44'!
selfAxisOn: aNodeSet select: aNodeTestBlock
	| copy |

	copy := aNodeSet copyEmpty.
	self documentOrderOn: aNodeSet do: [:each |
		(aNodeTestBlock value: each)
			ifTrue: [copy addLast: each]].
	^ copy sortOrder: self asDocumentSortOrder.! !

XPathSortOrder subclass: #XPathUnknownSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathUnknownSortOrder commentStamp: 'monty 2/10/2015 03:49' prior: 0!
A sort order for unsorted nodes or nodes in an unknown sort order.!

!XPathUnknownSortOrder methodsFor: 'private' stamp: 'monty 1/30/2015 19:19'!
documentOrderOn: aNodeSet do: aBlock
	aNodeSet sorted do: aBlock! !

!XPathUnknownSortOrder methodsFor: 'sorting' stamp: 'monty 2/3/2015 03:48'!
documentOrderSort: aNodeSet
	aNodeSet
		sort: [:a :b | a = b or: [a occursInDocumentBeforeNode: b]];
		sortOrder: XPathDocumentSortOrder new! !

!XPathUnknownSortOrder methodsFor: 'accessing' stamp: 'monty 2/3/2015 01:25'!
firstInDocumentOrderFrom: aNodeSet
	^ aNodeSet sorted first! !

!XPathUnknownSortOrder methodsFor: 'private' stamp: 'monty 2/3/2015 17:29'!
reverseDocumentOrderOn: aNodeSet do: aBlock
	aNodeSet sorted reverseDo: aBlock! !

!XPathUnknownSortOrder methodsFor: 'private' stamp: 'monty 2/10/2015 21:39'!
reverseDocumentOrderSort: aNodeSet
	aNodeSet
		sort: [:a :b | b occursInDocumentBeforeNode: a];
		sortOrder: XPathReverseDocumentSortOrder new! !

!XMLNodeWithElements methodsFor: '*XPath-Core-DOM' stamp: 'monty 2/10/2015 01:12'!
/ aNodeTestStringOrBlock
	"child axis"
	| nodeSet nodeTestBlock |

	nodeSet := self newNodeSet.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	self hasChildren
		ifTrue: [
			self nodesDo: [:each |
				(nodeTestBlock value: each)
					ifTrue: [nodeSet addLast: each]]].
	^ nodeSet sortOrder: XPathLevelDocumentSortOrder new.! !

!XMLNodeWithElements methodsFor: '*XPath-Core-DOM' stamp: 'monty 2/2/2015 18:12'!
// aNodeTestStringOrBlock
	"descendant axis"
	| nodeSet nodeTestBlock |

	nodeSet := self newNodeSet.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	self descendentNodesDo: [:each |
		(nodeTestBlock value: each)
			ifTrue: [nodeSet addLast: each]].
	^ nodeSet sortOrder: XPathDocumentSortOrder new.! !

!XMLNodeWithElements methodsFor: '*XPath-Core-DOM' stamp: 'monty 2/2/2015 18:12'!
//~ aNodeTestStringOrBlock
	"descendant-or-self axis"
	| nodeSet nodeTestBlock |

	nodeSet := self newNodeSet.
	nodeTestBlock := aNodeTestStringOrBlock asNodeTestBlock.
	self allNodesDo: [:each |
		(nodeTestBlock value: each)
			ifTrue: [nodeSet addLast: each]].
	^ nodeSet sortOrder: XPathDocumentSortOrder new.! !

!XMLNodeWithElements methodsFor: '*XPath-Core-DOM' stamp: 'monty 12/20/2014 20:55'!
asXPathString
	^ self rawContentString! !
XPathExpressionParserHandler initialize!
XPathNodeTestParser initialize!
XPathExpressionParser initialize!
XPath initialize!
